/* Client.c generated by valac 0.56.14, the Vala compiler
 * generated from Client.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2015 Adam Bieńkowski (https://launchpad.net/switchboard-plug-parental-controls)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <polkit/polkit.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <locale.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <unistd.h>

#define PC_CONSTANTS_GETTEXT_PACKAGE "parental-controls"
#define PC_CONSTANTS_LOCALEDIR "/usr/share/locale"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define PC_CLIENT_TYPE_CLIENT (pc_client_client_get_type ())
#define PC_CLIENT_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PC_CLIENT_TYPE_CLIENT, PCClientClient))
#define PC_CLIENT_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PC_CLIENT_TYPE_CLIENT, PCClientClientClass))
#define PC_CLIENT_IS_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PC_CLIENT_TYPE_CLIENT))
#define PC_CLIENT_IS_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PC_CLIENT_TYPE_CLIENT))
#define PC_CLIENT_CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PC_CLIENT_TYPE_CLIENT, PCClientClientClass))

typedef struct _PCClientClient PCClientClient;
typedef struct _PCClientClientClass PCClientClientClass;
typedef struct _PCClientClientPrivate PCClientClientPrivate;
enum  {
	PC_CLIENT_CLIENT_0_PROPERTY,
	PC_CLIENT_CLIENT_NUM_PROPERTIES
};
static GParamSpec* pc_client_client_properties[PC_CLIENT_CLIENT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define PC_TYPE_IPARENTAL_CONTROLS (pc_iparental_controls_get_type ())
#define PC_IPARENTAL_CONTROLS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PC_TYPE_IPARENTAL_CONTROLS, PCIParentalControls))
#define PC_IS_IPARENTAL_CONTROLS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PC_TYPE_IPARENTAL_CONTROLS))
#define PC_IPARENTAL_CONTROLS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PC_TYPE_IPARENTAL_CONTROLS, PCIParentalControlsIface))

typedef struct _PCIParentalControls PCIParentalControls;
typedef struct _PCIParentalControlsIface PCIParentalControlsIface;

#define PC_TYPE_IPARENTAL_CONTROLS_PROXY (pc_iparental_controls_proxy_get_type ())

#define PC_CLIENT_TYPE_APP_UNAVAILABLE_DIALOG (pc_client_app_unavailable_dialog_get_type ())
#define PC_CLIENT_APP_UNAVAILABLE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PC_CLIENT_TYPE_APP_UNAVAILABLE_DIALOG, PCClientAppUnavailableDialog))
#define PC_CLIENT_APP_UNAVAILABLE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PC_CLIENT_TYPE_APP_UNAVAILABLE_DIALOG, PCClientAppUnavailableDialogClass))
#define PC_CLIENT_IS_APP_UNAVAILABLE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PC_CLIENT_TYPE_APP_UNAVAILABLE_DIALOG))
#define PC_CLIENT_IS_APP_UNAVAILABLE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PC_CLIENT_TYPE_APP_UNAVAILABLE_DIALOG))
#define PC_CLIENT_APP_UNAVAILABLE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PC_CLIENT_TYPE_APP_UNAVAILABLE_DIALOG, PCClientAppUnavailableDialogClass))

typedef struct _PCClientAppUnavailableDialog PCClientAppUnavailableDialog;
typedef struct _PCClientAppUnavailableDialogClass PCClientAppUnavailableDialogClass;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
typedef struct _Block2Data Block2Data;

struct _PCClientClient {
	GtkApplication parent_instance;
	PCClientClientPrivate * priv;
};

struct _PCClientClientClass {
	GtkApplicationClass parent_class;
};

struct _PCClientClientPrivate {
	PolkitPermission* permission;
};

struct _PCIParentalControlsIface {
	GTypeInterface parent_iface;
	void (*add_restriction_for_user) (PCIParentalControls* self, const gchar* input, gboolean clean, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*add_restriction_for_user_finish) (PCIParentalControls* self, GAsyncResult* _res_, GError** error);
	void (*remove_restriction_for_user) (PCIParentalControls* self, const gchar* username, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*remove_restriction_for_user_finish) (PCIParentalControls* self, GAsyncResult* _res_, GError** error);
	void (*finish_app_authorization) (PCIParentalControls* self, const gchar* username, gchar** args, gint args_length1, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*finish_app_authorization_finish) (PCIParentalControls* self, GAsyncResult* _res_, GError** error);
	void (*get_user_daemon_active) (PCIParentalControls* self, const gchar* username, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*get_user_daemon_active_finish) (PCIParentalControls* self, GAsyncResult* _res_, GError** error);
	void (*get_user_daemon_admin) (PCIParentalControls* self, const gchar* username, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*get_user_daemon_admin_finish) (PCIParentalControls* self, GAsyncResult* _res_, GError** error);
	void (*get_user_daemon_block_urls) (PCIParentalControls* self, const gchar* username, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gchar** (*get_user_daemon_block_urls_finish) (PCIParentalControls* self, GAsyncResult* _res_, gint* result_length1, GError** error);
	void (*get_user_daemon_targets) (PCIParentalControls* self, const gchar* username, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gchar** (*get_user_daemon_targets_finish) (PCIParentalControls* self, GAsyncResult* _res_, gint* result_length1, GError** error);
	void (*lock_dock_icons_for_user) (PCIParentalControls* self, const gchar* username, gboolean lock, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*lock_dock_icons_for_user_finish) (PCIParentalControls* self, GAsyncResult* _res_, GError** error);
	void (*set_user_daemon_active) (PCIParentalControls* self, const gchar* username, gboolean active, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*set_user_daemon_active_finish) (PCIParentalControls* self, GAsyncResult* _res_, GError** error);
	void (*set_user_daemon_admin) (PCIParentalControls* self, const gchar* username, gboolean admin, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*set_user_daemon_admin_finish) (PCIParentalControls* self, GAsyncResult* _res_, GError** error);
	void (*set_user_daemon_block_urls) (PCIParentalControls* self, const gchar* username, gchar** block_urls, gint block_urls_length1, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*set_user_daemon_block_urls_finish) (PCIParentalControls* self, GAsyncResult* _res_, GError** error);
	void (*set_user_daemon_targets) (PCIParentalControls* self, const gchar* username, gchar** targets, gint targets_length1, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*set_user_daemon_targets_finish) (PCIParentalControls* self, GAsyncResult* _res_, GError** error);
};

struct _Block1Data {
	int _ref_count_;
	PCClientClient* self;
	gchar** argv;
	gint argv_length1;
	gint _argv_size_;
	gulong signal_id;
	gchar* username;
};

struct _Block2Data {
	int _ref_count_;
	Block1Data * _data1_;
	PCIParentalControls* api;
};

static gint PCClientClient_private_offset;
static gpointer pc_client_client_parent_class = NULL;
static gchar* pc_client_client_auth;
static gchar* pc_client_client_app_name;
static gchar* pc_client_client_app_name = NULL;
static gchar* pc_client_client_auth = NULL;

VALA_EXTERN GType pc_client_client_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PCClientClient, g_object_unref)
static gint pc_client_client_main (gchar** args,
                            gint args_length1);
VALA_EXTERN PCClientClient* pc_client_client_new (void);
VALA_EXTERN PCClientClient* pc_client_client_construct (GType object_type);
static void pc_client_client_real_activate (GApplication* base);
VALA_EXTERN GType pc_iparental_controls_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint pc_iparental_controls_register_object (void* object,
                                             GDBusConnection* connection,
                                             const gchar* path,
                                             GError** error);
VALA_EXTERN GType pc_iparental_controls_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PCIParentalControls, g_object_unref)
VALA_EXTERN PCIParentalControls* pc_utils_get_api (void);
VALA_EXTERN GType pc_client_app_unavailable_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PCClientAppUnavailableDialog, g_object_unref)
VALA_EXTERN PCClientAppUnavailableDialog* pc_client_app_unavailable_dialog_new (void);
VALA_EXTERN PCClientAppUnavailableDialog* pc_client_app_unavailable_dialog_construct (GType object_type);
static void pc_client_client_on_authorize (PCClientClient* self,
                                    const gchar* username,
                                    const gchar* action_id,
                                    gchar** _args,
                                    gint _args_length1);
static void pc_client_client_on_launch (PCClientClient* self,
                                 gchar** args,
                                 gint args_length1,
                                 gboolean incoming);
static void _pc_client_client_on_launch_pc_iparental_controls_launch (PCIParentalControls* _sender,
                                                               gchar** args,
                                                               gint args_length1,
                                                               gboolean incoming,
                                                               gpointer self);
static void pc_client_client_on_show_timeout (PCClientClient* self,
                                       gint hours,
                                       gint minutes);
static void _pc_client_client_on_show_timeout_pc_iparental_controls_show_timeout (PCIParentalControls* _sender,
                                                                           gint hours,
                                                                           gint minutes,
                                                                           gpointer self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void __lambda5_ (Block1Data* _data1_);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
VALA_EXTERN void pc_iparental_controls_finish_app_authorization (PCIParentalControls* self,
                                                     const gchar* username,
                                                     gchar** args,
                                                     gint args_length1,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
VALA_EXTERN void pc_iparental_controls_finish_app_authorization_finish (PCIParentalControls* self,
                                                            GAsyncResult* _res_,
                                                            GError** error);
static void __lambda6_ (Block2Data* _data2_,
                 GObject* obj,
                 GAsyncResult* res);
static void ___lambda6__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
static void ___lambda5__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void pc_client_client_finalize (GObject * obj);
static GType pc_client_client_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GOptionEntry PC_CLIENT_CLIENT_OPTIONS[3] = {{"authorize", 'a', (gint) 0, G_OPTION_ARG_STRING, &pc_client_client_auth, "Authorizes an application (format: username:action_id:arguments)", NULL}, {"dialog", 'd', (gint) 0, G_OPTION_ARG_STRING, &pc_client_client_app_name, "Show an unavailable dialog for the specified application name", NULL}, {NULL}};

static inline gpointer
pc_client_client_get_instance_private (PCClientClient* self)
{
	return G_STRUCT_MEMBER_P (self, PCClientClient_private_offset);
}

static gint
pc_client_client_main (gchar** args,
                       gint args_length1)
{
	PCClientClient* client = NULL;
	PCClientClient* _tmp9_;
	PCClientClient* _tmp10_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 52 "../src/client/Client.vala"
	setlocale (LC_ALL, "");
#line 53 "../src/client/Client.vala"
	bindtextdomain (PC_CONSTANTS_GETTEXT_PACKAGE, PC_CONSTANTS_LOCALEDIR);
#line 54 "../src/client/Client.vala"
	bind_textdomain_codeset (PC_CONSTANTS_GETTEXT_PACKAGE, "UTF-8");
#line 55 "../src/client/Client.vala"
	textdomain (PC_CONSTANTS_GETTEXT_PACKAGE);
#line 259 "Client.c"
	{
		GOptionContext* opt_context = NULL;
		GOptionContext* _tmp0_;
		GOptionContext* _tmp1_;
		GOptionContext* _tmp2_;
		GOptionContext* _tmp3_;
#line 58 "../src/client/Client.vala"
		_tmp0_ = g_option_context_new (NULL);
#line 58 "../src/client/Client.vala"
		opt_context = _tmp0_;
#line 59 "../src/client/Client.vala"
		_tmp1_ = opt_context;
#line 59 "../src/client/Client.vala"
		g_option_context_set_help_enabled (_tmp1_, TRUE);
#line 60 "../src/client/Client.vala"
		_tmp2_ = opt_context;
#line 60 "../src/client/Client.vala"
		g_option_context_add_main_entries (_tmp2_, PC_CLIENT_CLIENT_OPTIONS, NULL);
#line 61 "../src/client/Client.vala"
		_tmp3_ = opt_context;
#line 61 "../src/client/Client.vala"
		g_option_context_parse (_tmp3_, (gint*) (&args_length1), &args, &_inner_error0_);
#line 61 "../src/client/Client.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 284 "Client.c"
			gint _tmp4_ = -1;
#line 61 "../src/client/Client.vala"
			_g_option_context_free0 (opt_context);
#line 61 "../src/client/Client.vala"
			if (_inner_error0_->domain == G_OPTION_ERROR) {
#line 290 "Client.c"
				goto __catch0_g_option_error;
			}
#line 61 "../src/client/Client.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 61 "../src/client/Client.vala"
			g_clear_error (&_inner_error0_);
#line 61 "../src/client/Client.vala"
			return _tmp4_;
#line 299 "Client.c"
		}
#line 57 "../src/client/Client.vala"
		_g_option_context_free0 (opt_context);
#line 303 "Client.c"
	}
	goto __finally0;
	__catch0_g_option_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 57 "../src/client/Client.vala"
		e = _inner_error0_;
#line 57 "../src/client/Client.vala"
		_inner_error0_ = NULL;
#line 63 "../src/client/Client.vala"
		_tmp5_ = e;
#line 63 "../src/client/Client.vala"
		_tmp6_ = _tmp5_->message;
#line 63 "../src/client/Client.vala"
		g_print ("error: %s\n", _tmp6_);
#line 64 "../src/client/Client.vala"
		_tmp7_ = args[0];
#line 64 "../src/client/Client.vala"
		g_print ("Run '%s --help' to see a full list of available command line options.\n", _tmp7_);
#line 65 "../src/client/Client.vala"
		result = 0;
#line 65 "../src/client/Client.vala"
		_g_error_free0 (e);
#line 65 "../src/client/Client.vala"
		return result;
#line 332 "Client.c"
	}
	__finally0:
#line 57 "../src/client/Client.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 337 "Client.c"
		gint _tmp8_ = -1;
#line 57 "../src/client/Client.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 57 "../src/client/Client.vala"
		g_clear_error (&_inner_error0_);
#line 57 "../src/client/Client.vala"
		return _tmp8_;
#line 345 "Client.c"
	}
#line 68 "../src/client/Client.vala"
	_tmp9_ = pc_client_client_new ();
#line 68 "../src/client/Client.vala"
	client = _tmp9_;
#line 69 "../src/client/Client.vala"
	_tmp10_ = client;
#line 69 "../src/client/Client.vala"
	result = g_application_run ((GApplication*) _tmp10_, (gint) args_length1, args);
#line 69 "../src/client/Client.vala"
	_g_object_unref0 (client);
#line 69 "../src/client/Client.vala"
	return result;
#line 359 "Client.c"
}

int
main (int argc,
      char ** argv)
{
#line 51 "../src/client/Client.vala"
	return pc_client_client_main (argv, argc);
#line 368 "Client.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 73 "../src/client/Client.vala"
	return self ? g_object_ref (self) : NULL;
#line 376 "Client.c"
}

static void
_pc_client_client_on_launch_pc_iparental_controls_launch (PCIParentalControls* _sender,
                                                          gchar** args,
                                                          gint args_length1,
                                                          gboolean incoming,
                                                          gpointer self)
{
#line 98 "../src/client/Client.vala"
	pc_client_client_on_launch ((PCClientClient*) self, args, args_length1, incoming);
#line 388 "Client.c"
}

static void
_pc_client_client_on_show_timeout_pc_iparental_controls_show_timeout (PCIParentalControls* _sender,
                                                                      gint hours,
                                                                      gint minutes,
                                                                      gpointer self)
{
#line 99 "../src/client/Client.vala"
	pc_client_client_on_show_timeout ((PCClientClient*) self, hours, minutes);
#line 399 "Client.c"
}

static void
pc_client_client_real_activate (GApplication* base)
{
	PCClientClient * self;
	PCIParentalControls* api = NULL;
	PCIParentalControls* _tmp0_;
	PCIParentalControls* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp5_;
	PCIParentalControls* _tmp21_;
	PCIParentalControls* _tmp22_;
	GError* _inner_error0_ = NULL;
#line 72 "../src/client/Client.vala"
	self = (PCClientClient*) base;
#line 73 "../src/client/Client.vala"
	_tmp0_ = pc_utils_get_api ();
#line 73 "../src/client/Client.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 73 "../src/client/Client.vala"
	api = _tmp1_;
#line 75 "../src/client/Client.vala"
	_tmp2_ = pc_client_client_app_name;
#line 75 "../src/client/Client.vala"
	if (_tmp2_ != NULL) {
#line 426 "Client.c"
		PCClientAppUnavailableDialog* app_lock_dialog = NULL;
		PCClientAppUnavailableDialog* _tmp3_;
		PCClientAppUnavailableDialog* _tmp4_;
#line 76 "../src/client/Client.vala"
		_tmp3_ = pc_client_app_unavailable_dialog_new ();
#line 76 "../src/client/Client.vala"
		g_object_ref_sink (_tmp3_);
#line 76 "../src/client/Client.vala"
		app_lock_dialog = _tmp3_;
#line 77 "../src/client/Client.vala"
		_tmp4_ = app_lock_dialog;
#line 77 "../src/client/Client.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp4_);
#line 75 "../src/client/Client.vala"
		_g_object_unref0 (app_lock_dialog);
#line 442 "Client.c"
	}
#line 80 "../src/client/Client.vala"
	_tmp5_ = pc_client_client_auth;
#line 80 "../src/client/Client.vala"
	if (_tmp5_ != NULL) {
#line 448 "Client.c"
		gchar** tokens = NULL;
		const gchar* _tmp6_;
		gchar** _tmp7_;
		gchar** _tmp8_;
		gint tokens_length1;
		gint _tokens_size_;
		gchar** _tmp9_;
		gint _tmp9__length1;
#line 81 "../src/client/Client.vala"
		_tmp6_ = pc_client_client_auth;
#line 81 "../src/client/Client.vala"
		_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, ":", 3);
#line 81 "../src/client/Client.vala"
		tokens = _tmp8_;
#line 81 "../src/client/Client.vala"
		tokens_length1 = _vala_array_length (_tmp7_);
#line 81 "../src/client/Client.vala"
		_tokens_size_ = tokens_length1;
#line 82 "../src/client/Client.vala"
		_tmp9_ = tokens;
#line 82 "../src/client/Client.vala"
		_tmp9__length1 = tokens_length1;
#line 82 "../src/client/Client.vala"
		if (_tmp9__length1 == 3) {
#line 473 "Client.c"
			{
				gchar** argv = NULL;
				gint argv_length1 = 0;
				gint _argv_size_ = 0;
				gchar** _tmp10_;
				gint _tmp10__length1;
				const gchar* _tmp11_;
				gchar** _tmp12_ = NULL;
				gint _tmp13_ = 0;
				gchar** _tmp14_;
				gint _tmp14__length1;
				const gchar* _tmp15_;
				gchar** _tmp16_;
				gint _tmp16__length1;
				const gchar* _tmp17_;
				gchar** _tmp18_;
				gint _tmp18__length1;
#line 85 "../src/client/Client.vala"
				_tmp10_ = tokens;
#line 85 "../src/client/Client.vala"
				_tmp10__length1 = tokens_length1;
#line 85 "../src/client/Client.vala"
				_tmp11_ = _tmp10_[2];
#line 85 "../src/client/Client.vala"
				g_shell_parse_argv (_tmp11_, &_tmp13_, &_tmp12_, &_inner_error0_);
#line 85 "../src/client/Client.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 85 "../src/client/Client.vala"
				argv = _tmp12_;
#line 85 "../src/client/Client.vala"
				argv_length1 = _tmp13_;
#line 85 "../src/client/Client.vala"
				_argv_size_ = argv_length1;
#line 85 "../src/client/Client.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "../src/client/Client.vala"
					argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 85 "../src/client/Client.vala"
					if (_inner_error0_->domain == G_SHELL_ERROR) {
#line 513 "Client.c"
						goto __catch0_g_shell_error;
					}
#line 85 "../src/client/Client.vala"
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 85 "../src/client/Client.vala"
					_g_object_unref0 (api);
#line 85 "../src/client/Client.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 85 "../src/client/Client.vala"
					g_clear_error (&_inner_error0_);
#line 85 "../src/client/Client.vala"
					return;
#line 526 "Client.c"
				}
#line 87 "../src/client/Client.vala"
				_tmp14_ = tokens;
#line 87 "../src/client/Client.vala"
				_tmp14__length1 = tokens_length1;
#line 87 "../src/client/Client.vala"
				_tmp15_ = _tmp14_[0];
#line 87 "../src/client/Client.vala"
				_tmp16_ = tokens;
#line 87 "../src/client/Client.vala"
				_tmp16__length1 = tokens_length1;
#line 87 "../src/client/Client.vala"
				_tmp17_ = _tmp16_[1];
#line 87 "../src/client/Client.vala"
				_tmp18_ = argv;
#line 87 "../src/client/Client.vala"
				_tmp18__length1 = argv_length1;
#line 87 "../src/client/Client.vala"
				pc_client_client_on_authorize (self, _tmp15_, _tmp17_, _tmp18_, (gint) _tmp18__length1);
#line 83 "../src/client/Client.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 548 "Client.c"
			}
			goto __finally0;
			__catch0_g_shell_error:
			{
				gchar** _tmp19_;
				gint _tmp19__length1;
				const gchar* _tmp20_;
#line 83 "../src/client/Client.vala"
				g_clear_error (&_inner_error0_);
#line 89 "../src/client/Client.vala"
				_tmp19_ = tokens;
#line 89 "../src/client/Client.vala"
				_tmp19__length1 = tokens_length1;
#line 89 "../src/client/Client.vala"
				_tmp20_ = _tmp19_[2];
#line 89 "../src/client/Client.vala"
				g_print ("Failed to parse command line arguments: %s\n", _tmp20_);
#line 566 "Client.c"
			}
			__finally0:
#line 83 "../src/client/Client.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 83 "../src/client/Client.vala"
				tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 83 "../src/client/Client.vala"
				_g_object_unref0 (api);
#line 83 "../src/client/Client.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 83 "../src/client/Client.vala"
				g_clear_error (&_inner_error0_);
#line 83 "../src/client/Client.vala"
				return;
#line 581 "Client.c"
			}
		} else {
#line 92 "../src/client/Client.vala"
			g_print ("Usage: --authorize username:action_id:arguments");
#line 93 "../src/client/Client.vala"
			tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 93 "../src/client/Client.vala"
			_g_object_unref0 (api);
#line 93 "../src/client/Client.vala"
			return;
#line 592 "Client.c"
		}
#line 80 "../src/client/Client.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 596 "Client.c"
	}
#line 98 "../src/client/Client.vala"
	_tmp21_ = api;
#line 98 "../src/client/Client.vala"
	g_signal_connect_object (_tmp21_, "launch", (GCallback) _pc_client_client_on_launch_pc_iparental_controls_launch, self, 0);
#line 99 "../src/client/Client.vala"
	_tmp22_ = api;
#line 99 "../src/client/Client.vala"
	g_signal_connect_object (_tmp22_, "show-timeout", (GCallback) _pc_client_client_on_show_timeout_pc_iparental_controls_show_timeout, self, 0);
#line 101 "../src/client/Client.vala"
	gtk_main ();
#line 72 "../src/client/Client.vala"
	_g_object_unref0 (api);
#line 610 "Client.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 104 "../src/client/Client.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 104 "../src/client/Client.vala"
	return _data1_;
#line 620 "Client.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 104 "../src/client/Client.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 630 "Client.c"
		PCClientClient* self;
#line 104 "../src/client/Client.vala"
		self = _data1_->self;
#line 104 "../src/client/Client.vala"
		_data1_->argv = (_vala_array_free (_data1_->argv, _data1_->argv_length1, (GDestroyNotify) g_free), NULL);
#line 104 "../src/client/Client.vala"
		_g_free0 (_data1_->username);
#line 104 "../src/client/Client.vala"
		_g_object_unref0 (self);
#line 104 "../src/client/Client.vala"
		g_slice_free (Block1Data, _data1_);
#line 642 "Client.c"
	}
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 107 "../src/client/Client.vala"
	if ((*length) == (*size)) {
#line 107 "../src/client/Client.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 107 "../src/client/Client.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 658 "Client.c"
	}
#line 107 "../src/client/Client.vala"
	(*array)[(*length)++] = value;
#line 107 "../src/client/Client.vala"
	(*array)[*length] = NULL;
#line 664 "Client.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 127 "../src/client/Client.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 127 "../src/client/Client.vala"
	return _data2_;
#line 674 "Client.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 127 "../src/client/Client.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 684 "Client.c"
		PCClientClient* self;
#line 127 "../src/client/Client.vala"
		self = _data2_->_data1_->self;
#line 127 "../src/client/Client.vala"
		block1_data_unref (_data2_->_data1_);
#line 127 "../src/client/Client.vala"
		_data2_->_data1_ = NULL;
#line 127 "../src/client/Client.vala"
		g_slice_free (Block2Data, _data2_);
#line 694 "Client.c"
	}
}

static void
__lambda6_ (Block2Data* _data2_,
            GObject* obj,
            GAsyncResult* res)
{
	Block1Data* _data1_;
	PCClientClient* self;
	GError* _inner_error0_ = NULL;
#line 130 "../src/client/Client.vala"
	_data1_ = _data2_->_data1_;
#line 130 "../src/client/Client.vala"
	self = _data1_->self;
#line 130 "../src/client/Client.vala"
	g_return_if_fail (res != NULL);
#line 712 "Client.c"
	{
#line 132 "../src/client/Client.vala"
		pc_iparental_controls_finish_app_authorization_finish (_data2_->api, res, &_inner_error0_);
#line 132 "../src/client/Client.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 718 "Client.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 131 "../src/client/Client.vala"
		e = _inner_error0_;
#line 131 "../src/client/Client.vala"
		_inner_error0_ = NULL;
#line 134 "../src/client/Client.vala"
		_tmp0_ = e;
#line 134 "../src/client/Client.vala"
		_tmp1_ = _tmp0_->message;
#line 134 "../src/client/Client.vala"
		g_warning ("Client.vala:134: %s", _tmp1_);
#line 131 "../src/client/Client.vala"
		_g_error_free0 (e);
#line 740 "Client.c"
	}
	__finally0:
#line 131 "../src/client/Client.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 131 "../src/client/Client.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 131 "../src/client/Client.vala"
		g_clear_error (&_inner_error0_);
#line 131 "../src/client/Client.vala"
		return;
#line 751 "Client.c"
	}
}

static void
___lambda6__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 130 "../src/client/Client.vala"
	__lambda6_ (self, source_object, res);
#line 130 "../src/client/Client.vala"
	block2_data_unref (self);
#line 764 "Client.c"
}

static void
__lambda5_ (Block1Data* _data1_)
{
	PCClientClient* self;
	Block2Data* _data2_;
	PolkitPermission* _tmp0_;
	PCIParentalControls* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
#line 127 "../src/client/Client.vala"
	self = _data1_->self;
#line 127 "../src/client/Client.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 127 "../src/client/Client.vala"
	_data2_->_ref_count_ = 1;
#line 127 "../src/client/Client.vala"
	_data2_->_data1_ = block1_data_ref (_data1_);
#line 128 "../src/client/Client.vala"
	_tmp0_ = self->priv->permission;
#line 128 "../src/client/Client.vala"
	g_signal_handler_disconnect ((GObject*) _tmp0_, _data1_->signal_id);
#line 129 "../src/client/Client.vala"
	_tmp1_ = pc_utils_get_api ();
#line 129 "../src/client/Client.vala"
	_data2_->api = _tmp1_;
#line 130 "../src/client/Client.vala"
	_tmp2_ = _data1_->argv;
#line 130 "../src/client/Client.vala"
	_tmp2__length1 = _data1_->argv_length1;
#line 130 "../src/client/Client.vala"
	pc_iparental_controls_finish_app_authorization (_data2_->api, _data1_->username, _tmp2_, (gint) _tmp2__length1, ___lambda6__gasync_ready_callback, block2_data_ref (_data2_));
#line 127 "../src/client/Client.vala"
	block2_data_unref (_data2_);
#line 127 "../src/client/Client.vala"
	_data2_ = NULL;
#line 802 "Client.c"
}

static void
___lambda5__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 127 "../src/client/Client.vala"
	__lambda5_ (self);
#line 812 "Client.c"
}

static void
pc_client_client_on_authorize (PCClientClient* self,
                               const gchar* username,
                               const gchar* action_id,
                               gchar** _args,
                               gint _args_length1)
{
	Block1Data* _data1_;
	gchar* _tmp0_;
	gchar** _tmp1_;
	gboolean _tmp4_ = FALSE;
	PolkitPermission* _tmp5_;
	PolkitPermission* _tmp19_;
	gulong _tmp20_;
	PolkitPermission* _tmp21_;
	GError* _inner_error0_ = NULL;
#line 104 "../src/client/Client.vala"
	g_return_if_fail (self != NULL);
#line 104 "../src/client/Client.vala"
	g_return_if_fail (username != NULL);
#line 104 "../src/client/Client.vala"
	g_return_if_fail (action_id != NULL);
#line 104 "../src/client/Client.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 104 "../src/client/Client.vala"
	_data1_->_ref_count_ = 1;
#line 104 "../src/client/Client.vala"
	_data1_->self = g_object_ref (self);
#line 104 "../src/client/Client.vala"
	_tmp0_ = g_strdup (username);
#line 104 "../src/client/Client.vala"
	_g_free0 (_data1_->username);
#line 104 "../src/client/Client.vala"
	_data1_->username = _tmp0_;
#line 105 "../src/client/Client.vala"
	_tmp1_ = g_new0 (gchar*, 0 + 1);
#line 105 "../src/client/Client.vala"
	_data1_->argv = _tmp1_;
#line 105 "../src/client/Client.vala"
	_data1_->argv_length1 = 0;
#line 105 "../src/client/Client.vala"
	_data1_->_argv_size_ = _data1_->argv_length1;
#line 857 "Client.c"
	{
		gchar** arg_collection = NULL;
		gint arg_collection_length1 = 0;
		gint _arg_collection_size_ = 0;
		gint arg_it = 0;
#line 106 "../src/client/Client.vala"
		arg_collection = _args;
#line 106 "../src/client/Client.vala"
		arg_collection_length1 = _args_length1;
#line 106 "../src/client/Client.vala"
		for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
#line 869 "Client.c"
			const gchar* arg = NULL;
#line 106 "../src/client/Client.vala"
			arg = arg_collection[arg_it];
#line 873 "Client.c"
			{
				const gchar* _tmp2_;
				gchar* _tmp3_;
#line 107 "../src/client/Client.vala"
				_tmp2_ = arg;
#line 107 "../src/client/Client.vala"
				_tmp3_ = g_strdup (_tmp2_);
#line 107 "../src/client/Client.vala"
				_vala_array_add1 (&_data1_->argv, &_data1_->argv_length1, &_data1_->_argv_size_, _tmp3_);
#line 883 "Client.c"
			}
		}
	}
#line 110 "../src/client/Client.vala"
	_tmp5_ = self->priv->permission;
#line 110 "../src/client/Client.vala"
	if (_tmp5_ != NULL) {
#line 891 "Client.c"
		PolkitPermission* _tmp6_;
#line 110 "../src/client/Client.vala"
		_tmp6_ = self->priv->permission;
#line 110 "../src/client/Client.vala"
		_tmp4_ = g_permission_get_can_release ((GPermission*) _tmp6_);
#line 897 "Client.c"
	} else {
#line 110 "../src/client/Client.vala"
		_tmp4_ = FALSE;
#line 901 "Client.c"
	}
#line 110 "../src/client/Client.vala"
	if (_tmp4_) {
#line 905 "Client.c"
		{
			PolkitPermission* _tmp7_;
#line 112 "../src/client/Client.vala"
			_tmp7_ = self->priv->permission;
#line 112 "../src/client/Client.vala"
			g_permission_release ((GPermission*) _tmp7_, NULL, &_inner_error0_);
#line 112 "../src/client/Client.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 914 "Client.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp8_;
			const gchar* _tmp9_;
#line 111 "../src/client/Client.vala"
			e = _inner_error0_;
#line 111 "../src/client/Client.vala"
			_inner_error0_ = NULL;
#line 114 "../src/client/Client.vala"
			_tmp8_ = e;
#line 114 "../src/client/Client.vala"
			_tmp9_ = _tmp8_->message;
#line 114 "../src/client/Client.vala"
			g_critical ("Client.vala:114: %s", _tmp9_);
#line 111 "../src/client/Client.vala"
			_g_error_free0 (e);
#line 936 "Client.c"
		}
		__finally0:
#line 111 "../src/client/Client.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 111 "../src/client/Client.vala"
			block1_data_unref (_data1_);
#line 111 "../src/client/Client.vala"
			_data1_ = NULL;
#line 111 "../src/client/Client.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 111 "../src/client/Client.vala"
			g_clear_error (&_inner_error0_);
#line 111 "../src/client/Client.vala"
			return;
#line 951 "Client.c"
		}
	}
	{
		PolkitUnixUser* user = NULL;
		PolkitUnixUser* _tmp10_;
		PolkitUnixProcess* unixprocess = NULL;
		PolkitUnixUser* _tmp11_;
		PolkitUnixProcess* _tmp12_;
		PolkitPermission* _tmp13_ = NULL;
		PolkitUnixProcess* _tmp14_;
		PolkitPermission* _tmp15_;
		PolkitPermission* _tmp16_;
#line 119 "../src/client/Client.vala"
		_tmp10_ = (PolkitUnixUser*) polkit_unix_user_new_for_name (_data1_->username, &_inner_error0_);
#line 119 "../src/client/Client.vala"
		user = _tmp10_;
#line 119 "../src/client/Client.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 970 "Client.c"
			goto __catch1_g_error;
		}
#line 120 "../src/client/Client.vala"
		_tmp11_ = user;
#line 120 "../src/client/Client.vala"
		_tmp12_ = (PolkitUnixProcess*) polkit_unix_process_new_for_owner ((gint) getpid (), (guint64) 0, polkit_unix_user_get_uid (_tmp11_));
#line 120 "../src/client/Client.vala"
		unixprocess = _tmp12_;
#line 121 "../src/client/Client.vala"
		_tmp14_ = unixprocess;
#line 121 "../src/client/Client.vala"
		_tmp15_ = (PolkitPermission*) polkit_permission_new_sync (action_id, (PolkitSubject*) _tmp14_, NULL, &_inner_error0_);
#line 121 "../src/client/Client.vala"
		_tmp13_ = _tmp15_;
#line 121 "../src/client/Client.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 121 "../src/client/Client.vala"
			_g_object_unref0 (unixprocess);
#line 121 "../src/client/Client.vala"
			_g_object_unref0 (user);
#line 991 "Client.c"
			goto __catch1_g_error;
		}
#line 121 "../src/client/Client.vala"
		_tmp16_ = _tmp13_;
#line 121 "../src/client/Client.vala"
		_tmp13_ = NULL;
#line 121 "../src/client/Client.vala"
		_g_object_unref0 (self->priv->permission);
#line 121 "../src/client/Client.vala"
		self->priv->permission = _tmp16_;
#line 118 "../src/client/Client.vala"
		_g_object_unref0 (_tmp13_);
#line 118 "../src/client/Client.vala"
		_g_object_unref0 (unixprocess);
#line 118 "../src/client/Client.vala"
		_g_object_unref0 (user);
#line 1008 "Client.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 118 "../src/client/Client.vala"
		e = _inner_error0_;
#line 118 "../src/client/Client.vala"
		_inner_error0_ = NULL;
#line 123 "../src/client/Client.vala"
		_tmp17_ = e;
#line 123 "../src/client/Client.vala"
		_tmp18_ = _tmp17_->message;
#line 123 "../src/client/Client.vala"
		g_critical ("Client.vala:123: %s", _tmp18_);
#line 118 "../src/client/Client.vala"
		_g_error_free0 (e);
#line 1028 "Client.c"
	}
	__finally1:
#line 118 "../src/client/Client.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 118 "../src/client/Client.vala"
		block1_data_unref (_data1_);
#line 118 "../src/client/Client.vala"
		_data1_ = NULL;
#line 118 "../src/client/Client.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 118 "../src/client/Client.vala"
		g_clear_error (&_inner_error0_);
#line 118 "../src/client/Client.vala"
		return;
#line 1043 "Client.c"
	}
#line 126 "../src/client/Client.vala"
	_data1_->signal_id = (gulong) 0;
#line 127 "../src/client/Client.vala"
	_tmp19_ = self->priv->permission;
#line 127 "../src/client/Client.vala"
	_tmp20_ = g_signal_connect_data ((GObject*) _tmp19_, "notify::allowed", (GCallback) ___lambda5__g_object_notify, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 127 "../src/client/Client.vala"
	_data1_->signal_id = _tmp20_;
#line 139 "../src/client/Client.vala"
	_tmp21_ = self->priv->permission;
#line 139 "../src/client/Client.vala"
	g_permission_acquire_async ((GPermission*) _tmp21_, NULL, NULL, NULL);
#line 104 "../src/client/Client.vala"
	block1_data_unref (_data1_);
#line 104 "../src/client/Client.vala"
	_data1_ = NULL;
#line 1061 "Client.c"
}

static void
pc_client_client_on_launch (PCClientClient* self,
                            gchar** args,
                            gint args_length1,
                            gboolean incoming)
{
	PCIParentalControls* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 142 "../src/client/Client.vala"
	g_return_if_fail (self != NULL);
#line 143 "../src/client/Client.vala"
	if (!incoming) {
#line 144 "../src/client/Client.vala"
		return;
#line 1078 "Client.c"
	}
	{
		gchar** _tmp0_;
		gchar** _tmp1_;
		gchar** _tmp2_;
		gint _tmp2__length1;
#line 148 "../src/client/Client.vala"
		_tmp1_ = _tmp0_ = g_get_environ ();
#line 148 "../src/client/Client.vala"
		_tmp2_ = _tmp1_;
#line 148 "../src/client/Client.vala"
		_tmp2__length1 = _vala_array_length (_tmp0_);
#line 148 "../src/client/Client.vala"
		g_spawn_async ("/", args, _tmp2_, G_SPAWN_SEARCH_PATH | G_SPAWN_DO_NOT_REAP_CHILD, NULL, NULL, NULL, &_inner_error0_);
#line 148 "../src/client/Client.vala"
		_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 148 "../src/client/Client.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1097 "Client.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 147 "../src/client/Client.vala"
		e = _inner_error0_;
#line 147 "../src/client/Client.vala"
		_inner_error0_ = NULL;
#line 155 "../src/client/Client.vala"
		_tmp3_ = e;
#line 155 "../src/client/Client.vala"
		_tmp4_ = _tmp3_->message;
#line 155 "../src/client/Client.vala"
		g_warning ("Client.vala:155: %s\n", _tmp4_);
#line 147 "../src/client/Client.vala"
		_g_error_free0 (e);
#line 1119 "Client.c"
	}
	__finally0:
#line 147 "../src/client/Client.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 147 "../src/client/Client.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 147 "../src/client/Client.vala"
		g_clear_error (&_inner_error0_);
#line 147 "../src/client/Client.vala"
		return;
#line 1130 "Client.c"
	}
#line 158 "../src/client/Client.vala"
	_tmp5_ = pc_utils_get_api ();
#line 158 "../src/client/Client.vala"
	g_signal_emit_by_name (_tmp5_, "launch", args, (gint) args_length1, FALSE);
#line 1136 "Client.c"
}

static void
pc_client_client_on_show_timeout (PCClientClient* self,
                                  gint hours,
                                  gint minutes)
{
	gchar* body = NULL;
	gchar* _tmp0_;
	GNotification* notification = NULL;
	GNotification* _tmp13_;
	GThemedIcon* icon = NULL;
	GThemedIcon* _tmp14_;
	GNotification* _tmp15_;
	GThemedIcon* _tmp16_;
	GNotification* _tmp17_;
	const gchar* _tmp18_;
	GNotification* _tmp19_;
#line 162 "../src/client/Client.vala"
	g_return_if_fail (self != NULL);
#line 163 "../src/client/Client.vala"
	_tmp0_ = g_strdup (_ ("This computer will lock after %s."));
#line 163 "../src/client/Client.vala"
	body = _tmp0_;
#line 164 "../src/client/Client.vala"
	if (hours > 0) {
#line 1163 "Client.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 165 "../src/client/Client.vala"
		_tmp1_ = body;
#line 165 "../src/client/Client.vala"
		_tmp2_ = g_strdup_printf (ngettext ("%lu hour", "%lu hours", (gulong) hours), (gulong) hours);
#line 165 "../src/client/Client.vala"
		_tmp3_ = _tmp2_;
#line 165 "../src/client/Client.vala"
		_tmp4_ = g_strdup_printf (_tmp1_, _tmp3_);
#line 165 "../src/client/Client.vala"
		_g_free0 (body);
#line 165 "../src/client/Client.vala"
		body = _tmp4_;
#line 165 "../src/client/Client.vala"
		_g_free0 (_tmp3_);
#line 1182 "Client.c"
	} else {
#line 166 "../src/client/Client.vala"
		if (minutes > 0) {
#line 1186 "Client.c"
			const gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
#line 167 "../src/client/Client.vala"
			_tmp5_ = body;
#line 167 "../src/client/Client.vala"
			_tmp6_ = g_strdup_printf (ngettext ("%lu minute", "%lu minutes", (gulong) minutes), (gulong) minutes);
#line 167 "../src/client/Client.vala"
			_tmp7_ = _tmp6_;
#line 167 "../src/client/Client.vala"
			_tmp8_ = g_strdup_printf (_tmp5_, _tmp7_);
#line 167 "../src/client/Client.vala"
			_g_free0 (body);
#line 167 "../src/client/Client.vala"
			body = _tmp8_;
#line 167 "../src/client/Client.vala"
			_g_free0 (_tmp7_);
#line 168 "../src/client/Client.vala"
			if (minutes < 10) {
#line 1207 "Client.c"
				const gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
#line 169 "../src/client/Client.vala"
				_tmp9_ = body;
#line 169 "../src/client/Client.vala"
				_tmp10_ = g_strconcat ("\n", _ ("Make sure to close all applications before your computer will be locke" \
"d."), NULL);
#line 169 "../src/client/Client.vala"
				_tmp11_ = _tmp10_;
#line 169 "../src/client/Client.vala"
				_tmp12_ = g_strconcat (_tmp9_, _tmp11_, NULL);
#line 169 "../src/client/Client.vala"
				_g_free0 (body);
#line 169 "../src/client/Client.vala"
				body = _tmp12_;
#line 169 "../src/client/Client.vala"
				_g_free0 (_tmp11_);
#line 1226 "Client.c"
			}
		} else {
#line 172 "../src/client/Client.vala"
			_g_free0 (body);
#line 172 "../src/client/Client.vala"
			return;
#line 1233 "Client.c"
		}
	}
#line 175 "../src/client/Client.vala"
	_tmp13_ = g_notification_new (_ ("Time left"));
#line 175 "../src/client/Client.vala"
	notification = _tmp13_;
#line 176 "../src/client/Client.vala"
	_tmp14_ = (GThemedIcon*) g_themed_icon_new ("dialog-warning");
#line 176 "../src/client/Client.vala"
	icon = _tmp14_;
#line 177 "../src/client/Client.vala"
	_tmp15_ = notification;
#line 177 "../src/client/Client.vala"
	_tmp16_ = icon;
#line 177 "../src/client/Client.vala"
	g_notification_set_icon (_tmp15_, (GIcon*) _tmp16_);
#line 178 "../src/client/Client.vala"
	_tmp17_ = notification;
#line 178 "../src/client/Client.vala"
	_tmp18_ = body;
#line 178 "../src/client/Client.vala"
	g_notification_set_body (_tmp17_, _tmp18_);
#line 180 "../src/client/Client.vala"
	_tmp19_ = notification;
#line 180 "../src/client/Client.vala"
	g_application_send_notification ((GApplication*) self, "time-reminder", _tmp19_);
#line 162 "../src/client/Client.vala"
	_g_object_unref0 (icon);
#line 162 "../src/client/Client.vala"
	_g_object_unref0 (notification);
#line 162 "../src/client/Client.vala"
	_g_free0 (body);
#line 1266 "Client.c"
}

PCClientClient*
pc_client_client_construct (GType object_type)
{
	PCClientClient * self = NULL;
#line 24 "../src/client/Client.vala"
	self = (PCClientClient*) g_object_new (object_type, NULL);
#line 24 "../src/client/Client.vala"
	return self;
#line 1277 "Client.c"
}

PCClientClient*
pc_client_client_new (void)
{
#line 24 "../src/client/Client.vala"
	return pc_client_client_construct (PC_CLIENT_TYPE_CLIENT);
#line 1285 "Client.c"
}

static void
pc_client_client_class_init (PCClientClientClass * klass,
                             gpointer klass_data)
{
#line 24 "../src/client/Client.vala"
	pc_client_client_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/client/Client.vala"
	g_type_class_adjust_private_offset (klass, &PCClientClient_private_offset);
#line 24 "../src/client/Client.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) pc_client_client_real_activate;
#line 24 "../src/client/Client.vala"
	G_OBJECT_CLASS (klass)->finalize = pc_client_client_finalize;
#line 1300 "Client.c"
}

static void
pc_client_client_instance_init (PCClientClient * self,
                                gpointer klass)
{
#line 24 "../src/client/Client.vala"
	self->priv = pc_client_client_get_instance_private (self);
#line 25 "../src/client/Client.vala"
	self->priv->permission = NULL;
#line 1311 "Client.c"
}

static void
pc_client_client_finalize (GObject * obj)
{
	PCClientClient * self;
#line 24 "../src/client/Client.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PC_CLIENT_TYPE_CLIENT, PCClientClient);
#line 25 "../src/client/Client.vala"
	_g_object_unref0 (self->priv->permission);
#line 24 "../src/client/Client.vala"
	G_OBJECT_CLASS (pc_client_client_parent_class)->finalize (obj);
#line 1324 "Client.c"
}

static GType
pc_client_client_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PCClientClientClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pc_client_client_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PCClientClient), 0, (GInstanceInitFunc) pc_client_client_instance_init, NULL };
	GType pc_client_client_type_id;
	pc_client_client_type_id = g_type_register_static (gtk_application_get_type (), "PCClientClient", &g_define_type_info, 0);
	PCClientClient_private_offset = g_type_add_instance_private (pc_client_client_type_id, sizeof (PCClientClientPrivate));
	return pc_client_client_type_id;
}

GType
pc_client_client_get_type (void)
{
	static volatile gsize pc_client_client_type_id__once = 0;
	if (g_once_init_enter (&pc_client_client_type_id__once)) {
		GType pc_client_client_type_id;
		pc_client_client_type_id = pc_client_client_get_type_once ();
		g_once_init_leave (&pc_client_client_type_id__once, pc_client_client_type_id);
	}
	return pc_client_client_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

