/* Token.c generated by valac 0.56.14, the Vala compiler
 * generated from Token.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2015 Adam Bieńkowski (https://launchpad.net/switchboard-plug-parental-controls)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gobject/gvaluecollector.h>

#define PC_PAM_TOKEN_SERVICES_INDEX 0
#define PC_PAM_TOKEN_TTYS_INDEX 1
#define PC_PAM_TOKEN_USERS_INDEX 2
#define PC_PAM_TOKEN_TIMES_INDEX 3
#define PC_PAM_TOKEN_TYPE_SEPARATOR ";"
#define PC_PAM_TOKEN_LIST_SEPARATOR "|"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	PC_PAM_DAY_TYPE_UNKNOWN,
	PC_PAM_DAY_TYPE_ALL,
	PC_PAM_DAY_TYPE_WEEKDAY,
	PC_PAM_DAY_TYPE_WEEKEND
} PCPAMDayType;

#define PC_PAM_TYPE_DAY_TYPE (pc_pam_day_type_get_type ())

#define PC_PAM_TYPE_TIME_INFO (pc_pam_time_info_get_type ())
#define PC_PAM_TIME_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PC_PAM_TYPE_TIME_INFO, PCPAMTimeInfo))
#define PC_PAM_TIME_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PC_PAM_TYPE_TIME_INFO, PCPAMTimeInfoClass))
#define PC_PAM_IS_TIME_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PC_PAM_TYPE_TIME_INFO))
#define PC_PAM_IS_TIME_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PC_PAM_TYPE_TIME_INFO))
#define PC_PAM_TIME_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PC_PAM_TYPE_TIME_INFO, PCPAMTimeInfoClass))

typedef struct _PCPAMTimeInfo PCPAMTimeInfo;
typedef struct _PCPAMTimeInfoClass PCPAMTimeInfoClass;
typedef struct _PCPAMTimeInfoPrivate PCPAMTimeInfoPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _PCPAMParamSpecTimeInfo PCPAMParamSpecTimeInfo;

#define PC_PAM_TYPE_TOKEN (pc_pam_token_get_type ())
#define PC_PAM_TOKEN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PC_PAM_TYPE_TOKEN, PCPAMToken))
#define PC_PAM_TOKEN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PC_PAM_TYPE_TOKEN, PCPAMTokenClass))
#define PC_PAM_IS_TOKEN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PC_PAM_TYPE_TOKEN))
#define PC_PAM_IS_TOKEN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PC_PAM_TYPE_TOKEN))
#define PC_PAM_TOKEN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PC_PAM_TYPE_TOKEN, PCPAMTokenClass))

typedef struct _PCPAMToken PCPAMToken;
typedef struct _PCPAMTokenClass PCPAMTokenClass;
typedef struct _PCPAMTokenPrivate PCPAMTokenPrivate;
enum  {
	PC_PAM_TOKEN_0_PROPERTY,
	PC_PAM_TOKEN_NUM_PROPERTIES
};
static GParamSpec* pc_pam_token_properties[PC_PAM_TOKEN_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _pc_pam_time_info_unref0(var) ((var == NULL) ? NULL : (var = (pc_pam_time_info_unref (var), NULL)))

struct _PCPAMTimeInfo {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PCPAMTimeInfoPrivate * priv;
	PCPAMDayType day_type;
	gchar* from;
	gchar* to;
};

struct _PCPAMTimeInfoClass {
	GTypeClass parent_class;
	void (*finalize) (PCPAMTimeInfo *self);
};

struct _PCPAMParamSpecTimeInfo {
	GParamSpec parent_instance;
};

struct _PCPAMToken {
	GObject parent_instance;
	PCPAMTokenPrivate * priv;
	gchar** services;
	gint services_length1;
	gchar** ttys;
	gint ttys_length1;
	gchar** users;
	gint users_length1;
	gchar** times;
	gint times_length1;
};

struct _PCPAMTokenClass {
	GObjectClass parent_class;
};

static gpointer pc_pam_time_info_parent_class = NULL;
static gpointer pc_pam_token_parent_class = NULL;

VALA_EXTERN GType pc_pam_day_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PCPAMDayType pc_pam_day_type_to_enum (const gchar* str);
VALA_EXTERN gchar* pc_pam_day_type_to_string (PCPAMDayType self);
VALA_EXTERN gpointer pc_pam_time_info_ref (gpointer instance);
VALA_EXTERN void pc_pam_time_info_unref (gpointer instance);
VALA_EXTERN GParamSpec* pc_pam_param_spec_time_info (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
VALA_EXTERN void pc_pam_value_set_time_info (GValue* value,
                                 gpointer v_object);
VALA_EXTERN void pc_pam_value_take_time_info (GValue* value,
                                  gpointer v_object);
VALA_EXTERN gpointer pc_pam_value_get_time_info (const GValue* value);
VALA_EXTERN GType pc_pam_time_info_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PCPAMTimeInfo, pc_pam_time_info_unref)
VALA_EXTERN PCPAMTimeInfo* pc_pam_time_info_new (void);
VALA_EXTERN PCPAMTimeInfo* pc_pam_time_info_construct (GType object_type);
static void pc_pam_time_info_finalize (PCPAMTimeInfo * obj);
static GType pc_pam_time_info_get_type_once (void);
VALA_EXTERN GType pc_pam_token_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PCPAMToken, g_object_unref)
VALA_EXTERN PCPAMToken* pc_pam_token_parse_line (const gchar* line);
VALA_EXTERN PCPAMToken* pc_pam_token_new (void);
VALA_EXTERN PCPAMToken* pc_pam_token_construct (GType object_type);
VALA_EXTERN GList* pc_pam_token_parse (const gchar* str);
VALA_EXTERN gchar* pc_pam_token_construct_pam_restriction (gchar** services,
                                               gint services_length1,
                                               gchar** ttys,
                                               gint ttys_length1,
                                               gchar** users,
                                               gint users_length1,
                                               gchar** times,
                                               gint times_length1);
VALA_EXTERN gchar* pc_pam_token_construct_pam_restriction_simple (gchar** users,
                                                      gint users_length1,
                                                      gchar** times,
                                                      gint times_length1);
VALA_EXTERN GList* pc_pam_token_get_times_info (PCPAMToken* self);
VALA_EXTERN gchar* pc_pam_token_get_user_arg0 (PCPAMToken* self);
VALA_EXTERN gchar* pc_pam_token_to_string (PCPAMToken* self);
VALA_EXTERN void pc_pam_token_get_weekday_hours (PCPAMToken* self,
                                     gint* from,
                                     gint* to);
VALA_EXTERN void pc_pam_token_get_weekend_hours (PCPAMToken* self,
                                     gint* from,
                                     gint* to);
static void pc_pam_token_finalize (GObject * obj);
static GType pc_pam_token_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

PCPAMDayType
pc_pam_day_type_to_enum (const gchar* str)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 31 "../src/common/PAM/Token.vala"
	static GQuark _tmp1_label0 = 0;
#line 31 "../src/common/PAM/Token.vala"
	static GQuark _tmp1_label1 = 0;
#line 31 "../src/common/PAM/Token.vala"
	static GQuark _tmp1_label2 = 0;
#line 196 "Token.c"
	PCPAMDayType result;
#line 30 "../src/common/PAM/Token.vala"
	g_return_val_if_fail (str != NULL, 0);
#line 31 "../src/common/PAM/Token.vala"
	_tmp0_ = str;
#line 31 "../src/common/PAM/Token.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 31 "../src/common/PAM/Token.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("Al")))) {
#line 31 "../src/common/PAM/Token.vala"
		switch (0) {
#line 208 "Token.c"
			default:
			{
#line 33 "../src/common/PAM/Token.vala"
				result = PC_PAM_DAY_TYPE_ALL;
#line 33 "../src/common/PAM/Token.vala"
				return result;
#line 215 "Token.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("Wk")))) {
#line 31 "../src/common/PAM/Token.vala"
		switch (0) {
#line 221 "Token.c"
			default:
			{
#line 35 "../src/common/PAM/Token.vala"
				result = PC_PAM_DAY_TYPE_WEEKDAY;
#line 35 "../src/common/PAM/Token.vala"
				return result;
#line 228 "Token.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("Wd")))) {
#line 31 "../src/common/PAM/Token.vala"
		switch (0) {
#line 234 "Token.c"
			default:
			{
#line 37 "../src/common/PAM/Token.vala"
				result = PC_PAM_DAY_TYPE_WEEKEND;
#line 37 "../src/common/PAM/Token.vala"
				return result;
#line 241 "Token.c"
			}
		}
	} else {
#line 31 "../src/common/PAM/Token.vala"
		switch (0) {
#line 247 "Token.c"
			default:
			{
#line 39 "../src/common/PAM/Token.vala"
				result = PC_PAM_DAY_TYPE_UNKNOWN;
#line 39 "../src/common/PAM/Token.vala"
				return result;
#line 254 "Token.c"
			}
		}
	}
}

gchar*
pc_pam_day_type_to_string (PCPAMDayType self)
{
	gchar* result;
#line 44 "../src/common/PAM/Token.vala"
	switch (self) {
#line 44 "../src/common/PAM/Token.vala"
		case PC_PAM_DAY_TYPE_ALL:
#line 268 "Token.c"
		{
			gchar* _tmp0_;
#line 46 "../src/common/PAM/Token.vala"
			_tmp0_ = g_strdup ("Al");
#line 46 "../src/common/PAM/Token.vala"
			result = _tmp0_;
#line 46 "../src/common/PAM/Token.vala"
			return result;
#line 277 "Token.c"
		}
#line 44 "../src/common/PAM/Token.vala"
		case PC_PAM_DAY_TYPE_WEEKDAY:
#line 281 "Token.c"
		{
			gchar* _tmp1_;
#line 48 "../src/common/PAM/Token.vala"
			_tmp1_ = g_strdup ("Wk");
#line 48 "../src/common/PAM/Token.vala"
			result = _tmp1_;
#line 48 "../src/common/PAM/Token.vala"
			return result;
#line 290 "Token.c"
		}
#line 44 "../src/common/PAM/Token.vala"
		case PC_PAM_DAY_TYPE_WEEKEND:
#line 294 "Token.c"
		{
			gchar* _tmp2_;
#line 50 "../src/common/PAM/Token.vala"
			_tmp2_ = g_strdup ("Wd");
#line 50 "../src/common/PAM/Token.vala"
			result = _tmp2_;
#line 50 "../src/common/PAM/Token.vala"
			return result;
#line 303 "Token.c"
		}
		default:
#line 44 "../src/common/PAM/Token.vala"
		case PC_PAM_DAY_TYPE_UNKNOWN:
#line 308 "Token.c"
		{
			gchar* _tmp3_;
#line 53 "../src/common/PAM/Token.vala"
			_tmp3_ = g_strdup ("unknown");
#line 53 "../src/common/PAM/Token.vala"
			result = _tmp3_;
#line 53 "../src/common/PAM/Token.vala"
			return result;
#line 317 "Token.c"
		}
	}
}

static GType
pc_pam_day_type_get_type_once (void)
{
	static const GEnumValue values[] = {{PC_PAM_DAY_TYPE_UNKNOWN, "PC_PAM_DAY_TYPE_UNKNOWN", "unknown"}, {PC_PAM_DAY_TYPE_ALL, "PC_PAM_DAY_TYPE_ALL", "all"}, {PC_PAM_DAY_TYPE_WEEKDAY, "PC_PAM_DAY_TYPE_WEEKDAY", "weekday"}, {PC_PAM_DAY_TYPE_WEEKEND, "PC_PAM_DAY_TYPE_WEEKEND", "weekend"}, {0, NULL, NULL}};
	GType pc_pam_day_type_type_id;
	pc_pam_day_type_type_id = g_enum_register_static ("PCPAMDayType", values);
	return pc_pam_day_type_type_id;
}

GType
pc_pam_day_type_get_type (void)
{
	static volatile gsize pc_pam_day_type_type_id__once = 0;
	if (g_once_init_enter (&pc_pam_day_type_type_id__once)) {
		GType pc_pam_day_type_type_id;
		pc_pam_day_type_type_id = pc_pam_day_type_get_type_once ();
		g_once_init_leave (&pc_pam_day_type_type_id__once, pc_pam_day_type_type_id);
	}
	return pc_pam_day_type_type_id__once;
}

PCPAMTimeInfo*
pc_pam_time_info_construct (GType object_type)
{
	PCPAMTimeInfo* self = NULL;
#line 58 "../src/common/PAM/Token.vala"
	self = (PCPAMTimeInfo*) g_type_create_instance (object_type);
#line 58 "../src/common/PAM/Token.vala"
	return self;
#line 351 "Token.c"
}

PCPAMTimeInfo*
pc_pam_time_info_new (void)
{
#line 58 "../src/common/PAM/Token.vala"
	return pc_pam_time_info_construct (PC_PAM_TYPE_TIME_INFO);
#line 359 "Token.c"
}

static void
pc_pam_value_time_info_init (GValue* value)
{
#line 58 "../src/common/PAM/Token.vala"
	value->data[0].v_pointer = NULL;
#line 367 "Token.c"
}

static void
pc_pam_value_time_info_free_value (GValue* value)
{
#line 58 "../src/common/PAM/Token.vala"
	if (value->data[0].v_pointer) {
#line 58 "../src/common/PAM/Token.vala"
		pc_pam_time_info_unref (value->data[0].v_pointer);
#line 377 "Token.c"
	}
}

static void
pc_pam_value_time_info_copy_value (const GValue* src_value,
                                   GValue* dest_value)
{
#line 58 "../src/common/PAM/Token.vala"
	if (src_value->data[0].v_pointer) {
#line 58 "../src/common/PAM/Token.vala"
		dest_value->data[0].v_pointer = pc_pam_time_info_ref (src_value->data[0].v_pointer);
#line 389 "Token.c"
	} else {
#line 58 "../src/common/PAM/Token.vala"
		dest_value->data[0].v_pointer = NULL;
#line 393 "Token.c"
	}
}

static gpointer
pc_pam_value_time_info_peek_pointer (const GValue* value)
{
#line 58 "../src/common/PAM/Token.vala"
	return value->data[0].v_pointer;
#line 402 "Token.c"
}

static gchar*
pc_pam_value_time_info_collect_value (GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
#line 58 "../src/common/PAM/Token.vala"
	if (collect_values[0].v_pointer) {
#line 413 "Token.c"
		PCPAMTimeInfo * object;
		object = collect_values[0].v_pointer;
#line 58 "../src/common/PAM/Token.vala"
		if (object->parent_instance.g_class == NULL) {
#line 58 "../src/common/PAM/Token.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 420 "Token.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 58 "../src/common/PAM/Token.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 424 "Token.c"
		}
#line 58 "../src/common/PAM/Token.vala"
		value->data[0].v_pointer = pc_pam_time_info_ref (object);
#line 428 "Token.c"
	} else {
#line 58 "../src/common/PAM/Token.vala"
		value->data[0].v_pointer = NULL;
#line 432 "Token.c"
	}
#line 58 "../src/common/PAM/Token.vala"
	return NULL;
#line 436 "Token.c"
}

static gchar*
pc_pam_value_time_info_lcopy_value (const GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	PCPAMTimeInfo ** object_p;
	object_p = collect_values[0].v_pointer;
#line 58 "../src/common/PAM/Token.vala"
	if (!object_p) {
#line 58 "../src/common/PAM/Token.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 451 "Token.c"
	}
#line 58 "../src/common/PAM/Token.vala"
	if (!value->data[0].v_pointer) {
#line 58 "../src/common/PAM/Token.vala"
		*object_p = NULL;
#line 457 "Token.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 58 "../src/common/PAM/Token.vala"
		*object_p = value->data[0].v_pointer;
#line 461 "Token.c"
	} else {
#line 58 "../src/common/PAM/Token.vala"
		*object_p = pc_pam_time_info_ref (value->data[0].v_pointer);
#line 465 "Token.c"
	}
#line 58 "../src/common/PAM/Token.vala"
	return NULL;
#line 469 "Token.c"
}

GParamSpec*
pc_pam_param_spec_time_info (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags)
{
	PCPAMParamSpecTimeInfo* spec;
#line 58 "../src/common/PAM/Token.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PC_PAM_TYPE_TIME_INFO), NULL);
#line 58 "../src/common/PAM/Token.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 58 "../src/common/PAM/Token.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 58 "../src/common/PAM/Token.vala"
	return G_PARAM_SPEC (spec);
#line 488 "Token.c"
}

gpointer
pc_pam_value_get_time_info (const GValue* value)
{
#line 58 "../src/common/PAM/Token.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PC_PAM_TYPE_TIME_INFO), NULL);
#line 58 "../src/common/PAM/Token.vala"
	return value->data[0].v_pointer;
#line 498 "Token.c"
}

void
pc_pam_value_set_time_info (GValue* value,
                            gpointer v_object)
{
	PCPAMTimeInfo * old;
#line 58 "../src/common/PAM/Token.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PC_PAM_TYPE_TIME_INFO));
#line 58 "../src/common/PAM/Token.vala"
	old = value->data[0].v_pointer;
#line 58 "../src/common/PAM/Token.vala"
	if (v_object) {
#line 58 "../src/common/PAM/Token.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PC_PAM_TYPE_TIME_INFO));
#line 58 "../src/common/PAM/Token.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 58 "../src/common/PAM/Token.vala"
		value->data[0].v_pointer = v_object;
#line 58 "../src/common/PAM/Token.vala"
		pc_pam_time_info_ref (value->data[0].v_pointer);
#line 520 "Token.c"
	} else {
#line 58 "../src/common/PAM/Token.vala"
		value->data[0].v_pointer = NULL;
#line 524 "Token.c"
	}
#line 58 "../src/common/PAM/Token.vala"
	if (old) {
#line 58 "../src/common/PAM/Token.vala"
		pc_pam_time_info_unref (old);
#line 530 "Token.c"
	}
}

void
pc_pam_value_take_time_info (GValue* value,
                             gpointer v_object)
{
	PCPAMTimeInfo * old;
#line 58 "../src/common/PAM/Token.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PC_PAM_TYPE_TIME_INFO));
#line 58 "../src/common/PAM/Token.vala"
	old = value->data[0].v_pointer;
#line 58 "../src/common/PAM/Token.vala"
	if (v_object) {
#line 58 "../src/common/PAM/Token.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PC_PAM_TYPE_TIME_INFO));
#line 58 "../src/common/PAM/Token.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 58 "../src/common/PAM/Token.vala"
		value->data[0].v_pointer = v_object;
#line 551 "Token.c"
	} else {
#line 58 "../src/common/PAM/Token.vala"
		value->data[0].v_pointer = NULL;
#line 555 "Token.c"
	}
#line 58 "../src/common/PAM/Token.vala"
	if (old) {
#line 58 "../src/common/PAM/Token.vala"
		pc_pam_time_info_unref (old);
#line 561 "Token.c"
	}
}

static void
pc_pam_time_info_class_init (PCPAMTimeInfoClass * klass,
                             gpointer klass_data)
{
#line 58 "../src/common/PAM/Token.vala"
	pc_pam_time_info_parent_class = g_type_class_peek_parent (klass);
#line 58 "../src/common/PAM/Token.vala"
	((PCPAMTimeInfoClass *) klass)->finalize = pc_pam_time_info_finalize;
#line 573 "Token.c"
}

static void
pc_pam_time_info_instance_init (PCPAMTimeInfo * self,
                                gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 59 "../src/common/PAM/Token.vala"
	self->day_type = PC_PAM_DAY_TYPE_UNKNOWN;
#line 60 "../src/common/PAM/Token.vala"
	_tmp0_ = g_strdup ("");
#line 60 "../src/common/PAM/Token.vala"
	self->from = _tmp0_;
#line 61 "../src/common/PAM/Token.vala"
	_tmp1_ = g_strdup ("");
#line 61 "../src/common/PAM/Token.vala"
	self->to = _tmp1_;
#line 58 "../src/common/PAM/Token.vala"
	self->ref_count = 1;
#line 594 "Token.c"
}

static void
pc_pam_time_info_finalize (PCPAMTimeInfo * obj)
{
	PCPAMTimeInfo * self;
#line 58 "../src/common/PAM/Token.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PC_PAM_TYPE_TIME_INFO, PCPAMTimeInfo);
#line 58 "../src/common/PAM/Token.vala"
	g_signal_handlers_destroy (self);
#line 60 "../src/common/PAM/Token.vala"
	_g_free0 (self->from);
#line 61 "../src/common/PAM/Token.vala"
	_g_free0 (self->to);
#line 609 "Token.c"
}

static GType
pc_pam_time_info_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { pc_pam_value_time_info_init, pc_pam_value_time_info_free_value, pc_pam_value_time_info_copy_value, pc_pam_value_time_info_peek_pointer, "p", pc_pam_value_time_info_collect_value, "p", pc_pam_value_time_info_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PCPAMTimeInfoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pc_pam_time_info_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PCPAMTimeInfo), 0, (GInstanceInitFunc) pc_pam_time_info_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType pc_pam_time_info_type_id;
	pc_pam_time_info_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PCPAMTimeInfo", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return pc_pam_time_info_type_id;
}

GType
pc_pam_time_info_get_type (void)
{
	static volatile gsize pc_pam_time_info_type_id__once = 0;
	if (g_once_init_enter (&pc_pam_time_info_type_id__once)) {
		GType pc_pam_time_info_type_id;
		pc_pam_time_info_type_id = pc_pam_time_info_get_type_once ();
		g_once_init_leave (&pc_pam_time_info_type_id__once, pc_pam_time_info_type_id);
	}
	return pc_pam_time_info_type_id__once;
}

gpointer
pc_pam_time_info_ref (gpointer instance)
{
	PCPAMTimeInfo * self;
	self = instance;
#line 58 "../src/common/PAM/Token.vala"
	g_atomic_int_inc (&self->ref_count);
#line 58 "../src/common/PAM/Token.vala"
	return instance;
#line 644 "Token.c"
}

void
pc_pam_time_info_unref (gpointer instance)
{
	PCPAMTimeInfo * self;
	self = instance;
#line 58 "../src/common/PAM/Token.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 58 "../src/common/PAM/Token.vala"
		PC_PAM_TIME_INFO_GET_CLASS (self)->finalize (self);
#line 58 "../src/common/PAM/Token.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 658 "Token.c"
	}
}

PCPAMToken*
pc_pam_token_parse_line (const gchar* line)
{
	gchar** strv = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint strv_length1;
	gint _strv_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	PCPAMToken* token = NULL;
	PCPAMToken* _tmp3_;
	PCPAMToken* _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	const gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	PCPAMToken* _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	const gchar* _tmp11_;
	gchar** _tmp12_;
	gchar** _tmp13_;
	PCPAMToken* _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	const gchar* _tmp16_;
	gchar** _tmp17_;
	gchar** _tmp18_;
	PCPAMToken* _tmp19_;
	gchar** _tmp20_;
	gint _tmp20__length1;
	const gchar* _tmp21_;
	gchar** _tmp22_;
	gchar** _tmp23_;
	PCPAMToken* result;
#line 78 "../src/common/PAM/Token.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 79 "../src/common/PAM/Token.vala"
	_tmp1_ = _tmp0_ = g_strsplit (line, PC_PAM_TOKEN_TYPE_SEPARATOR, 0);
#line 79 "../src/common/PAM/Token.vala"
	strv = _tmp1_;
#line 79 "../src/common/PAM/Token.vala"
	strv_length1 = _vala_array_length (_tmp0_);
#line 79 "../src/common/PAM/Token.vala"
	_strv_size_ = strv_length1;
#line 80 "../src/common/PAM/Token.vala"
	_tmp2_ = strv;
#line 80 "../src/common/PAM/Token.vala"
	_tmp2__length1 = strv_length1;
#line 80 "../src/common/PAM/Token.vala"
	if (_tmp2__length1 != 4) {
#line 81 "../src/common/PAM/Token.vala"
		result = NULL;
#line 81 "../src/common/PAM/Token.vala"
		strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 81 "../src/common/PAM/Token.vala"
		return result;
#line 721 "Token.c"
	}
#line 84 "../src/common/PAM/Token.vala"
	_tmp3_ = pc_pam_token_new ();
#line 84 "../src/common/PAM/Token.vala"
	token = _tmp3_;
#line 85 "../src/common/PAM/Token.vala"
	_tmp4_ = token;
#line 85 "../src/common/PAM/Token.vala"
	_tmp5_ = strv;
#line 85 "../src/common/PAM/Token.vala"
	_tmp5__length1 = strv_length1;
#line 85 "../src/common/PAM/Token.vala"
	_tmp6_ = _tmp5_[PC_PAM_TOKEN_SERVICES_INDEX];
#line 85 "../src/common/PAM/Token.vala"
	_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, PC_PAM_TOKEN_LIST_SEPARATOR, 0);
#line 85 "../src/common/PAM/Token.vala"
	_tmp4_->services = (_vala_array_free (_tmp4_->services, _tmp4_->services_length1, (GDestroyNotify) g_free), NULL);
#line 85 "../src/common/PAM/Token.vala"
	_tmp4_->services = _tmp8_;
#line 85 "../src/common/PAM/Token.vala"
	_tmp4_->services_length1 = _vala_array_length (_tmp7_);
#line 86 "../src/common/PAM/Token.vala"
	_tmp9_ = token;
#line 86 "../src/common/PAM/Token.vala"
	_tmp10_ = strv;
#line 86 "../src/common/PAM/Token.vala"
	_tmp10__length1 = strv_length1;
#line 86 "../src/common/PAM/Token.vala"
	_tmp11_ = _tmp10_[PC_PAM_TOKEN_TTYS_INDEX];
#line 86 "../src/common/PAM/Token.vala"
	_tmp13_ = _tmp12_ = g_strsplit (_tmp11_, PC_PAM_TOKEN_LIST_SEPARATOR, 0);
#line 86 "../src/common/PAM/Token.vala"
	_tmp9_->ttys = (_vala_array_free (_tmp9_->ttys, _tmp9_->ttys_length1, (GDestroyNotify) g_free), NULL);
#line 86 "../src/common/PAM/Token.vala"
	_tmp9_->ttys = _tmp13_;
#line 86 "../src/common/PAM/Token.vala"
	_tmp9_->ttys_length1 = _vala_array_length (_tmp12_);
#line 87 "../src/common/PAM/Token.vala"
	_tmp14_ = token;
#line 87 "../src/common/PAM/Token.vala"
	_tmp15_ = strv;
#line 87 "../src/common/PAM/Token.vala"
	_tmp15__length1 = strv_length1;
#line 87 "../src/common/PAM/Token.vala"
	_tmp16_ = _tmp15_[PC_PAM_TOKEN_USERS_INDEX];
#line 87 "../src/common/PAM/Token.vala"
	_tmp18_ = _tmp17_ = g_strsplit (_tmp16_, PC_PAM_TOKEN_LIST_SEPARATOR, 0);
#line 87 "../src/common/PAM/Token.vala"
	_tmp14_->users = (_vala_array_free (_tmp14_->users, _tmp14_->users_length1, (GDestroyNotify) g_free), NULL);
#line 87 "../src/common/PAM/Token.vala"
	_tmp14_->users = _tmp18_;
#line 87 "../src/common/PAM/Token.vala"
	_tmp14_->users_length1 = _vala_array_length (_tmp17_);
#line 88 "../src/common/PAM/Token.vala"
	_tmp19_ = token;
#line 88 "../src/common/PAM/Token.vala"
	_tmp20_ = strv;
#line 88 "../src/common/PAM/Token.vala"
	_tmp20__length1 = strv_length1;
#line 88 "../src/common/PAM/Token.vala"
	_tmp21_ = _tmp20_[PC_PAM_TOKEN_TIMES_INDEX];
#line 88 "../src/common/PAM/Token.vala"
	_tmp23_ = _tmp22_ = g_strsplit (_tmp21_, PC_PAM_TOKEN_LIST_SEPARATOR, 0);
#line 88 "../src/common/PAM/Token.vala"
	_tmp19_->times = (_vala_array_free (_tmp19_->times, _tmp19_->times_length1, (GDestroyNotify) g_free), NULL);
#line 88 "../src/common/PAM/Token.vala"
	_tmp19_->times = _tmp23_;
#line 88 "../src/common/PAM/Token.vala"
	_tmp19_->times_length1 = _vala_array_length (_tmp22_);
#line 89 "../src/common/PAM/Token.vala"
	result = token;
#line 89 "../src/common/PAM/Token.vala"
	strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 89 "../src/common/PAM/Token.vala"
	return result;
#line 797 "Token.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 98 "../src/common/PAM/Token.vala"
	return self ? g_object_ref (self) : NULL;
#line 805 "Token.c"
}

GList*
pc_pam_token_parse (const gchar* str)
{
	GList* list = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	GList* result;
#line 92 "../src/common/PAM/Token.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 93 "../src/common/PAM/Token.vala"
	list = NULL;
#line 95 "../src/common/PAM/Token.vala"
	_tmp1_ = _tmp0_ = g_strsplit (str, "\n", 0);
#line 821 "Token.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 95 "../src/common/PAM/Token.vala"
		line_collection = _tmp1_;
#line 95 "../src/common/PAM/Token.vala"
		line_collection_length1 = _vala_array_length (_tmp0_);
#line 95 "../src/common/PAM/Token.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 833 "Token.c"
			gchar* _tmp2_;
			gchar* line = NULL;
#line 95 "../src/common/PAM/Token.vala"
			_tmp2_ = g_strdup (line_collection[line_it]);
#line 95 "../src/common/PAM/Token.vala"
			line = _tmp2_;
#line 840 "Token.c"
			{
				PCPAMToken* token = NULL;
				const gchar* _tmp3_;
				PCPAMToken* _tmp4_;
				PCPAMToken* _tmp5_;
#line 96 "../src/common/PAM/Token.vala"
				_tmp3_ = line;
#line 96 "../src/common/PAM/Token.vala"
				_tmp4_ = pc_pam_token_parse_line (_tmp3_);
#line 96 "../src/common/PAM/Token.vala"
				token = _tmp4_;
#line 97 "../src/common/PAM/Token.vala"
				_tmp5_ = token;
#line 97 "../src/common/PAM/Token.vala"
				if (_tmp5_ != NULL) {
#line 856 "Token.c"
					PCPAMToken* _tmp6_;
					PCPAMToken* _tmp7_;
#line 98 "../src/common/PAM/Token.vala"
					_tmp6_ = token;
#line 98 "../src/common/PAM/Token.vala"
					_tmp7_ = _g_object_ref0 (_tmp6_);
#line 98 "../src/common/PAM/Token.vala"
					list = g_list_append (list, _tmp7_);
#line 865 "Token.c"
				}
#line 95 "../src/common/PAM/Token.vala"
				_g_object_unref0 (token);
#line 95 "../src/common/PAM/Token.vala"
				_g_free0 (line);
#line 871 "Token.c"
			}
		}
#line 95 "../src/common/PAM/Token.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 876 "Token.c"
	}
#line 102 "../src/common/PAM/Token.vala"
	result = list;
#line 102 "../src/common/PAM/Token.vala"
	return result;
#line 882 "Token.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 896 "Token.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 900 "Token.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 906 "Token.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 911 "Token.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 917 "Token.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 921 "Token.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 925 "Token.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 929 "Token.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 933 "Token.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 937 "Token.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 952 "Token.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 961 "Token.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 968 "Token.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 974 "Token.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 982 "Token.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 986 "Token.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 992 "Token.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 997 "Token.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 1003 "Token.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 1007 "Token.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 1011 "Token.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 1017 "Token.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 1023 "Token.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 1035 "Token.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 1039 "Token.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 1043 "Token.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 1048 "Token.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 1056 "Token.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 1074 "Token.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 1080 "Token.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 1084 "Token.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 1092 "Token.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 1101 "Token.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 1110 "Token.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 1116 "Token.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 1124 "Token.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 1136 "Token.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 1142 "Token.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 1146 "Token.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 1154 "Token.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 1165 "Token.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 1174 "Token.c"
	}
}

gchar*
pc_pam_token_construct_pam_restriction (gchar** services,
                                        gint services_length1,
                                        gchar** ttys,
                                        gint ttys_length1,
                                        gchar** users,
                                        gint users_length1,
                                        gchar** times,
                                        gint times_length1)
{
	gchar* services_str = NULL;
	gchar* _tmp0_;
	gchar* ttys_str = NULL;
	gchar* _tmp1_;
	gchar* users_str = NULL;
	gchar* _tmp2_;
	gchar* times_str = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 108 "../src/common/PAM/Token.vala"
	_tmp0_ = _vala_g_strjoinv (PC_PAM_TOKEN_LIST_SEPARATOR, services, (gint) services_length1);
#line 108 "../src/common/PAM/Token.vala"
	services_str = _tmp0_;
#line 109 "../src/common/PAM/Token.vala"
	_tmp1_ = _vala_g_strjoinv (PC_PAM_TOKEN_LIST_SEPARATOR, ttys, (gint) ttys_length1);
#line 109 "../src/common/PAM/Token.vala"
	ttys_str = _tmp1_;
#line 110 "../src/common/PAM/Token.vala"
	_tmp2_ = _vala_g_strjoinv (PC_PAM_TOKEN_LIST_SEPARATOR, users, (gint) users_length1);
#line 110 "../src/common/PAM/Token.vala"
	users_str = _tmp2_;
#line 111 "../src/common/PAM/Token.vala"
	_tmp3_ = _vala_g_strjoinv (PC_PAM_TOKEN_LIST_SEPARATOR, times, (gint) times_length1);
#line 111 "../src/common/PAM/Token.vala"
	times_str = _tmp3_;
#line 113 "../src/common/PAM/Token.vala"
	_tmp4_ = g_strdup_printf ("%s;%s;%s;%s", services_str, ttys_str, users_str, times_str);
#line 113 "../src/common/PAM/Token.vala"
	result = _tmp4_;
#line 113 "../src/common/PAM/Token.vala"
	_g_free0 (times_str);
#line 113 "../src/common/PAM/Token.vala"
	_g_free0 (users_str);
#line 113 "../src/common/PAM/Token.vala"
	_g_free0 (ttys_str);
#line 113 "../src/common/PAM/Token.vala"
	_g_free0 (services_str);
#line 113 "../src/common/PAM/Token.vala"
	return result;
#line 1228 "Token.c"
}

gchar*
pc_pam_token_construct_pam_restriction_simple (gchar** users,
                                               gint users_length1,
                                               gchar** times,
                                               gint times_length1)
{
	gchar* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 117 "../src/common/PAM/Token.vala"
	_tmp0_ = g_strdup ("*");
#line 117 "../src/common/PAM/Token.vala"
	_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 117 "../src/common/PAM/Token.vala"
	_tmp1_[0] = _tmp0_;
#line 117 "../src/common/PAM/Token.vala"
	_tmp2_ = _tmp1_;
#line 117 "../src/common/PAM/Token.vala"
	_tmp2__length1 = 1;
#line 117 "../src/common/PAM/Token.vala"
	_tmp3_ = g_strdup ("*");
#line 117 "../src/common/PAM/Token.vala"
	_tmp4_ = g_new0 (gchar*, 1 + 1);
#line 117 "../src/common/PAM/Token.vala"
	_tmp4_[0] = _tmp3_;
#line 117 "../src/common/PAM/Token.vala"
	_tmp5_ = _tmp4_;
#line 117 "../src/common/PAM/Token.vala"
	_tmp5__length1 = 1;
#line 117 "../src/common/PAM/Token.vala"
	_tmp6_ = pc_pam_token_construct_pam_restriction (_tmp2_, (gint) 1, _tmp5_, (gint) 1, users, (gint) users_length1, times, (gint) times_length1);
#line 117 "../src/common/PAM/Token.vala"
	_tmp7_ = _tmp6_;
#line 117 "../src/common/PAM/Token.vala"
	_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 117 "../src/common/PAM/Token.vala"
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 117 "../src/common/PAM/Token.vala"
	result = _tmp7_;
#line 117 "../src/common/PAM/Token.vala"
	return result;
#line 1280 "Token.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1458 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1458 "glib-2.0.vapi"
	end = _tmp0_;
#line 1459 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1459 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1460 "glib-2.0.vapi"
		result = maxlen;
#line 1460 "glib-2.0.vapi"
		return result;
#line 1303 "Token.c"
	} else {
		gchar* _tmp2_;
#line 1462 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1462 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1462 "glib-2.0.vapi"
		return result;
#line 1312 "Token.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1469 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1471 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1331 "Token.c"
	} else {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1335 "Token.c"
	}
#line 1471 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1473 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1341 "Token.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1475 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1475 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1475 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1351 "Token.c"
	}
#line 1478 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1480 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1359 "Token.c"
	} else {
#line 1482 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1363 "Token.c"
	}
#line 1484 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1485 "glib-2.0.vapi"
		len = string_length - offset;
#line 1369 "Token.c"
	}
#line 1487 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1488 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1488 "glib-2.0.vapi"
	result = _tmp3_;
#line 1488 "glib-2.0.vapi"
	return result;
#line 1379 "Token.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1491 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1492 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1492 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1492 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1493 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		start = string_length + start;
#line 1406 "Token.c"
	}
#line 1496 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		end = string_length + end;
#line 1412 "Token.c"
	}
#line 1499 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1499 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1418 "Token.c"
	} else {
#line 1499 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1422 "Token.c"
	}
#line 1499 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1500 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1500 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1430 "Token.c"
	} else {
#line 1500 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1434 "Token.c"
	}
#line 1500 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1501 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1502 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1502 "glib-2.0.vapi"
	result = _tmp4_;
#line 1502 "glib-2.0.vapi"
	return result;
#line 1446 "Token.c"
}

static gpointer
_pc_pam_time_info_ref0 (gpointer self)
{
#line 138 "../src/common/PAM/Token.vala"
	return self ? pc_pam_time_info_ref (self) : NULL;
#line 1454 "Token.c"
}

GList*
pc_pam_token_get_times_info (PCPAMToken* self)
{
	GList* list = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	GList* result;
#line 120 "../src/common/PAM/Token.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 121 "../src/common/PAM/Token.vala"
	list = NULL;
#line 123 "../src/common/PAM/Token.vala"
	_tmp0_ = self->times;
#line 123 "../src/common/PAM/Token.vala"
	_tmp0__length1 = self->times_length1;
#line 123 "../src/common/PAM/Token.vala"
	if (_tmp0__length1 == 0) {
#line 124 "../src/common/PAM/Token.vala"
		result = list;
#line 124 "../src/common/PAM/Token.vala"
		return result;
#line 1480 "Token.c"
	}
#line 127 "../src/common/PAM/Token.vala"
	_tmp1_ = self->times;
#line 127 "../src/common/PAM/Token.vala"
	_tmp1__length1 = self->times_length1;
#line 1486 "Token.c"
	{
		gchar** time_collection = NULL;
		gint time_collection_length1 = 0;
		gint _time_collection_size_ = 0;
		gint time_it = 0;
#line 127 "../src/common/PAM/Token.vala"
		time_collection = _tmp1_;
#line 127 "../src/common/PAM/Token.vala"
		time_collection_length1 = _tmp1__length1;
#line 127 "../src/common/PAM/Token.vala"
		for (time_it = 0; time_it < time_collection_length1; time_it = time_it + 1) {
#line 1498 "Token.c"
			gchar* _tmp2_;
			gchar* time = NULL;
#line 127 "../src/common/PAM/Token.vala"
			_tmp2_ = g_strdup (time_collection[time_it]);
#line 127 "../src/common/PAM/Token.vala"
			time = _tmp2_;
#line 1505 "Token.c"
			{
				gchar** bounds = NULL;
				const gchar* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				gchar** _tmp6_;
				gchar** _tmp7_;
				gchar** _tmp8_;
				gint _tmp8__length1;
				gint bounds_length1;
				gint _bounds_size_;
				gchar** _tmp9_;
				gint _tmp9__length1;
				PCPAMTimeInfo* info = NULL;
				PCPAMTimeInfo* _tmp10_;
				PCPAMTimeInfo* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				PCPAMTimeInfo* _tmp15_;
				gchar** _tmp16_;
				gint _tmp16__length1;
				const gchar* _tmp17_;
				gchar* _tmp18_;
				PCPAMTimeInfo* _tmp19_;
				gchar** _tmp20_;
				gint _tmp20__length1;
				const gchar* _tmp21_;
				gchar* _tmp22_;
				PCPAMTimeInfo* _tmp23_;
				PCPAMTimeInfo* _tmp24_;
#line 128 "../src/common/PAM/Token.vala"
				_tmp3_ = time;
#line 128 "../src/common/PAM/Token.vala"
				_tmp4_ = string_substring (_tmp3_, (glong) 2, (glong) -1);
#line 128 "../src/common/PAM/Token.vala"
				_tmp5_ = _tmp4_;
#line 128 "../src/common/PAM/Token.vala"
				_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "-", 0);
#line 128 "../src/common/PAM/Token.vala"
				_tmp8_ = _tmp7_;
#line 128 "../src/common/PAM/Token.vala"
				_tmp8__length1 = _vala_array_length (_tmp6_);
#line 128 "../src/common/PAM/Token.vala"
				_g_free0 (_tmp5_);
#line 128 "../src/common/PAM/Token.vala"
				bounds = _tmp8_;
#line 128 "../src/common/PAM/Token.vala"
				bounds_length1 = _tmp8__length1;
#line 128 "../src/common/PAM/Token.vala"
				_bounds_size_ = bounds_length1;
#line 129 "../src/common/PAM/Token.vala"
				_tmp9_ = bounds;
#line 129 "../src/common/PAM/Token.vala"
				_tmp9__length1 = bounds_length1;
#line 129 "../src/common/PAM/Token.vala"
				if (_tmp9__length1 < 2) {
#line 130 "../src/common/PAM/Token.vala"
					bounds = (_vala_array_free (bounds, bounds_length1, (GDestroyNotify) g_free), NULL);
#line 130 "../src/common/PAM/Token.vala"
					_g_free0 (time);
#line 130 "../src/common/PAM/Token.vala"
					continue;
#line 1569 "Token.c"
				}
#line 133 "../src/common/PAM/Token.vala"
				_tmp10_ = pc_pam_time_info_new ();
#line 133 "../src/common/PAM/Token.vala"
				info = _tmp10_;
#line 134 "../src/common/PAM/Token.vala"
				_tmp11_ = info;
#line 134 "../src/common/PAM/Token.vala"
				_tmp12_ = time;
#line 134 "../src/common/PAM/Token.vala"
				_tmp13_ = string_slice (_tmp12_, (glong) 0, (glong) 2);
#line 134 "../src/common/PAM/Token.vala"
				_tmp14_ = _tmp13_;
#line 134 "../src/common/PAM/Token.vala"
				_tmp11_->day_type = pc_pam_day_type_to_enum (_tmp14_);
#line 134 "../src/common/PAM/Token.vala"
				_g_free0 (_tmp14_);
#line 135 "../src/common/PAM/Token.vala"
				_tmp15_ = info;
#line 135 "../src/common/PAM/Token.vala"
				_tmp16_ = bounds;
#line 135 "../src/common/PAM/Token.vala"
				_tmp16__length1 = bounds_length1;
#line 135 "../src/common/PAM/Token.vala"
				_tmp17_ = _tmp16_[0];
#line 135 "../src/common/PAM/Token.vala"
				_tmp18_ = g_strdup (_tmp17_);
#line 135 "../src/common/PAM/Token.vala"
				_g_free0 (_tmp15_->from);
#line 135 "../src/common/PAM/Token.vala"
				_tmp15_->from = _tmp18_;
#line 136 "../src/common/PAM/Token.vala"
				_tmp19_ = info;
#line 136 "../src/common/PAM/Token.vala"
				_tmp20_ = bounds;
#line 136 "../src/common/PAM/Token.vala"
				_tmp20__length1 = bounds_length1;
#line 136 "../src/common/PAM/Token.vala"
				_tmp21_ = _tmp20_[1];
#line 136 "../src/common/PAM/Token.vala"
				_tmp22_ = g_strdup (_tmp21_);
#line 136 "../src/common/PAM/Token.vala"
				_g_free0 (_tmp19_->to);
#line 136 "../src/common/PAM/Token.vala"
				_tmp19_->to = _tmp22_;
#line 138 "../src/common/PAM/Token.vala"
				_tmp23_ = info;
#line 138 "../src/common/PAM/Token.vala"
				_tmp24_ = _pc_pam_time_info_ref0 (_tmp23_);
#line 138 "../src/common/PAM/Token.vala"
				list = g_list_append (list, _tmp24_);
#line 127 "../src/common/PAM/Token.vala"
				_pc_pam_time_info_unref0 (info);
#line 127 "../src/common/PAM/Token.vala"
				bounds = (_vala_array_free (bounds, bounds_length1, (GDestroyNotify) g_free), NULL);
#line 127 "../src/common/PAM/Token.vala"
				_g_free0 (time);
#line 1627 "Token.c"
			}
		}
	}
#line 141 "../src/common/PAM/Token.vala"
	result = list;
#line 141 "../src/common/PAM/Token.vala"
	return result;
#line 1635 "Token.c"
}

gchar*
pc_pam_token_get_user_arg0 (PCPAMToken* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp2_;
	gint _tmp2__length1;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 144 "../src/common/PAM/Token.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 145 "../src/common/PAM/Token.vala"
	_tmp0_ = self->users;
#line 145 "../src/common/PAM/Token.vala"
	_tmp0__length1 = self->users_length1;
#line 145 "../src/common/PAM/Token.vala"
	if (_tmp0__length1 == 0) {
#line 1656 "Token.c"
		gchar* _tmp1_;
#line 146 "../src/common/PAM/Token.vala"
		_tmp1_ = g_strdup ("");
#line 146 "../src/common/PAM/Token.vala"
		result = _tmp1_;
#line 146 "../src/common/PAM/Token.vala"
		return result;
#line 1664 "Token.c"
	}
#line 149 "../src/common/PAM/Token.vala"
	_tmp2_ = self->users;
#line 149 "../src/common/PAM/Token.vala"
	_tmp2__length1 = self->users_length1;
#line 149 "../src/common/PAM/Token.vala"
	_tmp3_ = _tmp2_[0];
#line 149 "../src/common/PAM/Token.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 149 "../src/common/PAM/Token.vala"
	result = _tmp4_;
#line 149 "../src/common/PAM/Token.vala"
	return result;
#line 1678 "Token.c"
}

gchar*
pc_pam_token_to_string (PCPAMToken* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gchar* result;
#line 152 "../src/common/PAM/Token.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 153 "../src/common/PAM/Token.vala"
	_tmp0_ = self->services;
#line 153 "../src/common/PAM/Token.vala"
	_tmp0__length1 = self->services_length1;
#line 153 "../src/common/PAM/Token.vala"
	_tmp1_ = self->ttys;
#line 153 "../src/common/PAM/Token.vala"
	_tmp1__length1 = self->ttys_length1;
#line 153 "../src/common/PAM/Token.vala"
	_tmp2_ = self->users;
#line 153 "../src/common/PAM/Token.vala"
	_tmp2__length1 = self->users_length1;
#line 153 "../src/common/PAM/Token.vala"
	_tmp3_ = self->times;
#line 153 "../src/common/PAM/Token.vala"
	_tmp3__length1 = self->times_length1;
#line 153 "../src/common/PAM/Token.vala"
	_tmp4_ = pc_pam_token_construct_pam_restriction (_tmp0_, (gint) _tmp0__length1, _tmp1_, (gint) _tmp1__length1, _tmp2_, (gint) _tmp2__length1, _tmp3_, (gint) _tmp3__length1);
#line 153 "../src/common/PAM/Token.vala"
	result = _tmp4_;
#line 153 "../src/common/PAM/Token.vala"
	return result;
#line 1718 "Token.c"
}

void
pc_pam_token_get_weekday_hours (PCPAMToken* self,
                                gint* from,
                                gint* to)
{
	gint _vala_from = 0;
	gint _vala_to = 0;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** bounds = NULL;
	gchar** _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gint bounds_length1;
	gint _bounds_size_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar** _tmp9_;
	gint _tmp9__length1;
	const gchar* _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	const gchar* _tmp12_;
#line 156 "../src/common/PAM/Token.vala"
	g_return_if_fail (self != NULL);
#line 157 "../src/common/PAM/Token.vala"
	_tmp0_ = self->times;
#line 157 "../src/common/PAM/Token.vala"
	_tmp0__length1 = self->times_length1;
#line 157 "../src/common/PAM/Token.vala"
	if (_tmp0__length1 < 1) {
#line 158 "../src/common/PAM/Token.vala"
		_vala_from = 0;
#line 159 "../src/common/PAM/Token.vala"
		_vala_to = 0;
#line 160 "../src/common/PAM/Token.vala"
		if (from) {
#line 160 "../src/common/PAM/Token.vala"
			*from = _vala_from;
#line 1766 "Token.c"
		}
#line 160 "../src/common/PAM/Token.vala"
		if (to) {
#line 160 "../src/common/PAM/Token.vala"
			*to = _vala_to;
#line 1772 "Token.c"
		}
#line 160 "../src/common/PAM/Token.vala"
		return;
#line 1776 "Token.c"
	}
#line 163 "../src/common/PAM/Token.vala"
	_tmp1_ = self->times;
#line 163 "../src/common/PAM/Token.vala"
	_tmp1__length1 = self->times_length1;
#line 163 "../src/common/PAM/Token.vala"
	_tmp2_ = _tmp1_[0];
#line 163 "../src/common/PAM/Token.vala"
	_tmp3_ = string_substring (_tmp2_, (glong) 2, (glong) -1);
#line 163 "../src/common/PAM/Token.vala"
	_tmp4_ = _tmp3_;
#line 163 "../src/common/PAM/Token.vala"
	_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, "-", 0);
#line 163 "../src/common/PAM/Token.vala"
	_tmp7_ = _tmp6_;
#line 163 "../src/common/PAM/Token.vala"
	_tmp7__length1 = _vala_array_length (_tmp5_);
#line 163 "../src/common/PAM/Token.vala"
	_g_free0 (_tmp4_);
#line 163 "../src/common/PAM/Token.vala"
	bounds = _tmp7_;
#line 163 "../src/common/PAM/Token.vala"
	bounds_length1 = _tmp7__length1;
#line 163 "../src/common/PAM/Token.vala"
	_bounds_size_ = bounds_length1;
#line 164 "../src/common/PAM/Token.vala"
	_tmp8_ = bounds;
#line 164 "../src/common/PAM/Token.vala"
	_tmp8__length1 = bounds_length1;
#line 164 "../src/common/PAM/Token.vala"
	if (_tmp8__length1 < 2) {
#line 165 "../src/common/PAM/Token.vala"
		_vala_from = 0;
#line 166 "../src/common/PAM/Token.vala"
		_vala_to = 0;
#line 167 "../src/common/PAM/Token.vala"
		bounds = (_vala_array_free (bounds, bounds_length1, (GDestroyNotify) g_free), NULL);
#line 167 "../src/common/PAM/Token.vala"
		if (from) {
#line 167 "../src/common/PAM/Token.vala"
			*from = _vala_from;
#line 1818 "Token.c"
		}
#line 167 "../src/common/PAM/Token.vala"
		if (to) {
#line 167 "../src/common/PAM/Token.vala"
			*to = _vala_to;
#line 1824 "Token.c"
		}
#line 167 "../src/common/PAM/Token.vala"
		return;
#line 1828 "Token.c"
	}
#line 170 "../src/common/PAM/Token.vala"
	_tmp9_ = bounds;
#line 170 "../src/common/PAM/Token.vala"
	_tmp9__length1 = bounds_length1;
#line 170 "../src/common/PAM/Token.vala"
	_tmp10_ = _tmp9_[0];
#line 170 "../src/common/PAM/Token.vala"
	_vala_from = atoi (_tmp10_);
#line 171 "../src/common/PAM/Token.vala"
	_tmp11_ = bounds;
#line 171 "../src/common/PAM/Token.vala"
	_tmp11__length1 = bounds_length1;
#line 171 "../src/common/PAM/Token.vala"
	_tmp12_ = _tmp11_[1];
#line 171 "../src/common/PAM/Token.vala"
	_vala_to = atoi (_tmp12_);
#line 156 "../src/common/PAM/Token.vala"
	bounds = (_vala_array_free (bounds, bounds_length1, (GDestroyNotify) g_free), NULL);
#line 156 "../src/common/PAM/Token.vala"
	if (from) {
#line 156 "../src/common/PAM/Token.vala"
		*from = _vala_from;
#line 1852 "Token.c"
	}
#line 156 "../src/common/PAM/Token.vala"
	if (to) {
#line 156 "../src/common/PAM/Token.vala"
		*to = _vala_to;
#line 1858 "Token.c"
	}
}

void
pc_pam_token_get_weekend_hours (PCPAMToken* self,
                                gint* from,
                                gint* to)
{
	gint _vala_from = 0;
	gint _vala_to = 0;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** bounds = NULL;
	gchar** _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint bounds_length1;
	gint _bounds_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar** _tmp6_;
	gint _tmp6__length1;
	const gchar* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
#line 174 "../src/common/PAM/Token.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/common/PAM/Token.vala"
	_tmp0_ = self->times;
#line 175 "../src/common/PAM/Token.vala"
	_tmp0__length1 = self->times_length1;
#line 175 "../src/common/PAM/Token.vala"
	if (_tmp0__length1 < 2) {
#line 176 "../src/common/PAM/Token.vala"
		_vala_from = 0;
#line 177 "../src/common/PAM/Token.vala"
		_vala_to = 0;
#line 178 "../src/common/PAM/Token.vala"
		if (from) {
#line 178 "../src/common/PAM/Token.vala"
			*from = _vala_from;
#line 1903 "Token.c"
		}
#line 178 "../src/common/PAM/Token.vala"
		if (to) {
#line 178 "../src/common/PAM/Token.vala"
			*to = _vala_to;
#line 1909 "Token.c"
		}
#line 178 "../src/common/PAM/Token.vala"
		return;
#line 1913 "Token.c"
	}
#line 181 "../src/common/PAM/Token.vala"
	_tmp1_ = self->times;
#line 181 "../src/common/PAM/Token.vala"
	_tmp1__length1 = self->times_length1;
#line 181 "../src/common/PAM/Token.vala"
	_tmp2_ = _tmp1_[1];
#line 181 "../src/common/PAM/Token.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, "-", 0);
#line 181 "../src/common/PAM/Token.vala"
	bounds = _tmp4_;
#line 181 "../src/common/PAM/Token.vala"
	bounds_length1 = _vala_array_length (_tmp3_);
#line 181 "../src/common/PAM/Token.vala"
	_bounds_size_ = bounds_length1;
#line 182 "../src/common/PAM/Token.vala"
	_tmp5_ = bounds;
#line 182 "../src/common/PAM/Token.vala"
	_tmp5__length1 = bounds_length1;
#line 182 "../src/common/PAM/Token.vala"
	if (_tmp5__length1 < 2) {
#line 183 "../src/common/PAM/Token.vala"
		_vala_from = 0;
#line 184 "../src/common/PAM/Token.vala"
		_vala_to = 0;
#line 185 "../src/common/PAM/Token.vala"
		bounds = (_vala_array_free (bounds, bounds_length1, (GDestroyNotify) g_free), NULL);
#line 185 "../src/common/PAM/Token.vala"
		if (from) {
#line 185 "../src/common/PAM/Token.vala"
			*from = _vala_from;
#line 1945 "Token.c"
		}
#line 185 "../src/common/PAM/Token.vala"
		if (to) {
#line 185 "../src/common/PAM/Token.vala"
			*to = _vala_to;
#line 1951 "Token.c"
		}
#line 185 "../src/common/PAM/Token.vala"
		return;
#line 1955 "Token.c"
	}
#line 188 "../src/common/PAM/Token.vala"
	_tmp6_ = bounds;
#line 188 "../src/common/PAM/Token.vala"
	_tmp6__length1 = bounds_length1;
#line 188 "../src/common/PAM/Token.vala"
	_tmp7_ = _tmp6_[0];
#line 188 "../src/common/PAM/Token.vala"
	_vala_from = atoi (_tmp7_);
#line 189 "../src/common/PAM/Token.vala"
	_tmp8_ = bounds;
#line 189 "../src/common/PAM/Token.vala"
	_tmp8__length1 = bounds_length1;
#line 189 "../src/common/PAM/Token.vala"
	_tmp9_ = _tmp8_[1];
#line 189 "../src/common/PAM/Token.vala"
	_vala_to = atoi (_tmp9_);
#line 174 "../src/common/PAM/Token.vala"
	bounds = (_vala_array_free (bounds, bounds_length1, (GDestroyNotify) g_free), NULL);
#line 174 "../src/common/PAM/Token.vala"
	if (from) {
#line 174 "../src/common/PAM/Token.vala"
		*from = _vala_from;
#line 1979 "Token.c"
	}
#line 174 "../src/common/PAM/Token.vala"
	if (to) {
#line 174 "../src/common/PAM/Token.vala"
		*to = _vala_to;
#line 1985 "Token.c"
	}
}

PCPAMToken*
pc_pam_token_construct (GType object_type)
{
	PCPAMToken * self = NULL;
#line 64 "../src/common/PAM/Token.vala"
	self = (PCPAMToken*) g_object_new (object_type, NULL);
#line 64 "../src/common/PAM/Token.vala"
	return self;
#line 1997 "Token.c"
}

PCPAMToken*
pc_pam_token_new (void)
{
#line 64 "../src/common/PAM/Token.vala"
	return pc_pam_token_construct (PC_PAM_TYPE_TOKEN);
#line 2005 "Token.c"
}

static void
pc_pam_token_class_init (PCPAMTokenClass * klass,
                         gpointer klass_data)
{
#line 64 "../src/common/PAM/Token.vala"
	pc_pam_token_parent_class = g_type_class_peek_parent (klass);
#line 64 "../src/common/PAM/Token.vala"
	G_OBJECT_CLASS (klass)->finalize = pc_pam_token_finalize;
#line 2016 "Token.c"
}

static void
pc_pam_token_instance_init (PCPAMToken * self,
                            gpointer klass)
{
}

static void
pc_pam_token_finalize (GObject * obj)
{
	PCPAMToken * self;
#line 64 "../src/common/PAM/Token.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PC_PAM_TYPE_TOKEN, PCPAMToken);
#line 73 "../src/common/PAM/Token.vala"
	self->services = (_vala_array_free (self->services, self->services_length1, (GDestroyNotify) g_free), NULL);
#line 74 "../src/common/PAM/Token.vala"
	self->ttys = (_vala_array_free (self->ttys, self->ttys_length1, (GDestroyNotify) g_free), NULL);
#line 75 "../src/common/PAM/Token.vala"
	self->users = (_vala_array_free (self->users, self->users_length1, (GDestroyNotify) g_free), NULL);
#line 76 "../src/common/PAM/Token.vala"
	self->times = (_vala_array_free (self->times, self->times_length1, (GDestroyNotify) g_free), NULL);
#line 64 "../src/common/PAM/Token.vala"
	G_OBJECT_CLASS (pc_pam_token_parent_class)->finalize (obj);
#line 2041 "Token.c"
}

static GType
pc_pam_token_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PCPAMTokenClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pc_pam_token_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PCPAMToken), 0, (GInstanceInitFunc) pc_pam_token_instance_init, NULL };
	GType pc_pam_token_type_id;
	pc_pam_token_type_id = g_type_register_static (G_TYPE_OBJECT, "PCPAMToken", &g_define_type_info, 0);
	return pc_pam_token_type_id;
}

GType
pc_pam_token_get_type (void)
{
	static volatile gsize pc_pam_token_type_id__once = 0;
	if (g_once_init_enter (&pc_pam_token_type_id__once)) {
		GType pc_pam_token_type_id;
		pc_pam_token_type_id = pc_pam_token_get_type_once ();
		g_once_init_leave (&pc_pam_token_type_id__once, pc_pam_token_type_id);
	}
	return pc_pam_token_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

