/* UserConfig.c generated by valac 0.56.14, the Vala compiler
 * generated from UserConfig.vala, do not modify */

/*
 * Copyright 2019 elementary, Inc. (https://elementary.io)
 *           2015-2016 Adam Bieńkowski
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <act/act.h>

#define PC_CONSTANTS_DAEMON_CONF_FILE "/etc/pantheon-parental-controls/daemon.conf"
#define PC_CONSTANTS_DAEMON_KEY_ACTIVE "Active"
#define PC_CONSTANTS_DAEMON_KEY_TARGETS "Targets"
#define PC_CONSTANTS_DAEMON_KEY_BLOCK_URLS "BlockUrls"
#define PC_CONSTANTS_DAEMON_KEY_ADMIN "Admin"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define PC_DAEMON_TYPE_USER_CONFIG (pc_daemon_user_config_get_type ())
#define PC_DAEMON_USER_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PC_DAEMON_TYPE_USER_CONFIG, PCDaemonUserConfig))
#define PC_DAEMON_USER_CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PC_DAEMON_TYPE_USER_CONFIG, PCDaemonUserConfigClass))
#define PC_DAEMON_IS_USER_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PC_DAEMON_TYPE_USER_CONFIG))
#define PC_DAEMON_IS_USER_CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PC_DAEMON_TYPE_USER_CONFIG))
#define PC_DAEMON_USER_CONFIG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PC_DAEMON_TYPE_USER_CONFIG, PCDaemonUserConfigClass))

typedef struct _PCDaemonUserConfig PCDaemonUserConfig;
typedef struct _PCDaemonUserConfigClass PCDaemonUserConfigClass;
typedef struct _PCDaemonUserConfigPrivate PCDaemonUserConfigPrivate;
enum  {
	PC_DAEMON_USER_CONFIG_0_PROPERTY,
	PC_DAEMON_USER_CONFIG_USERNAME_PROPERTY,
	PC_DAEMON_USER_CONFIG_ACTIVE_PROPERTY,
	PC_DAEMON_USER_CONFIG_TARGETS_PROPERTY,
	PC_DAEMON_USER_CONFIG_BLOCK_URLS_PROPERTY,
	PC_DAEMON_USER_CONFIG_ADMIN_PROPERTY,
	PC_DAEMON_USER_CONFIG_NUM_PROPERTIES
};
static GParamSpec* pc_daemon_user_config_properties[PC_DAEMON_USER_CONFIG_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define PC_DAEMON_TYPE_SERVER (pc_daemon_server_get_type ())
#define PC_DAEMON_SERVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PC_DAEMON_TYPE_SERVER, PCDaemonServer))
#define PC_DAEMON_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PC_DAEMON_TYPE_SERVER, PCDaemonServerClass))
#define PC_DAEMON_IS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PC_DAEMON_TYPE_SERVER))
#define PC_DAEMON_IS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PC_DAEMON_TYPE_SERVER))
#define PC_DAEMON_SERVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PC_DAEMON_TYPE_SERVER, PCDaemonServerClass))

typedef struct _PCDaemonServer PCDaemonServer;
typedef struct _PCDaemonServerClass PCDaemonServerClass;

struct _PCDaemonUserConfig {
	GObject parent_instance;
	PCDaemonUserConfigPrivate * priv;
};

struct _PCDaemonUserConfigClass {
	GObjectClass parent_class;
};

struct _PCDaemonUserConfigPrivate {
	gchar* _username;
};

static gint PCDaemonUserConfig_private_offset;
static gpointer pc_daemon_user_config_parent_class = NULL;
static GKeyFile* pc_daemon_user_config_key;
static GKeyFile* pc_daemon_user_config_key = NULL;
static GList* pc_daemon_user_config_config_list;
static GList* pc_daemon_user_config_config_list = NULL;

VALA_EXTERN GType pc_daemon_user_config_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PCDaemonUserConfig, g_object_unref)
VALA_EXTERN PCDaemonUserConfig* pc_daemon_user_config_get_for_username (const gchar* username,
                                                            gboolean create);
VALA_EXTERN const gchar* pc_daemon_user_config_get_username (PCDaemonUserConfig* self);
static PCDaemonUserConfig* pc_daemon_user_config_create_for_username (const gchar* username);
VALA_EXTERN GList* pc_daemon_user_config_get_all (void);
VALA_EXTERN void pc_daemon_user_config_init (void);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gboolean pc_daemon_user_config_init_config_file (void);
static PCDaemonUserConfig* pc_daemon_user_config_new (const gchar* username);
static PCDaemonUserConfig* pc_daemon_user_config_construct (GType object_type,
                                                     const gchar* username);
VALA_EXTERN ActUserManager* pc_utils_get_usermanager (void);
VALA_EXTERN void pc_daemon_user_config_set_active (PCDaemonUserConfig* self,
                                       gboolean value);
VALA_EXTERN void pc_daemon_user_config_set_username (PCDaemonUserConfig* self,
                                         const gchar* value);
static void pc_daemon_user_config_save (PCDaemonUserConfig* self);
VALA_EXTERN GType pc_daemon_server_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PCDaemonServer, g_object_unref)
VALA_EXTERN guint pc_daemon_server_register_object (void* object,
                                        GDBusConnection* connection,
                                        const gchar* path,
                                        GError** error);
VALA_EXTERN PCDaemonServer* pc_daemon_server_get_default (void);
VALA_EXTERN gboolean pc_daemon_user_config_get_active (PCDaemonUserConfig* self);
VALA_EXTERN gchar** pc_daemon_user_config_get_targets (PCDaemonUserConfig* self,
                                           gint* result_length1);
VALA_EXTERN void pc_daemon_user_config_set_targets (PCDaemonUserConfig* self,
                                        gchar** value,
                                        gint value_length1);
VALA_EXTERN gchar** pc_daemon_user_config_get_block_urls (PCDaemonUserConfig* self,
                                              gint* result_length1);
VALA_EXTERN void pc_daemon_user_config_set_block_urls (PCDaemonUserConfig* self,
                                           gchar** value,
                                           gint value_length1);
VALA_EXTERN gboolean pc_daemon_user_config_get_admin (PCDaemonUserConfig* self);
VALA_EXTERN void pc_daemon_user_config_set_admin (PCDaemonUserConfig* self,
                                      gboolean value);
static void pc_daemon_user_config_finalize (GObject * obj);
static GType pc_daemon_user_config_get_type_once (void);
static void _vala_pc_daemon_user_config_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_pc_daemon_user_config_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
pc_daemon_user_config_get_instance_private (PCDaemonUserConfig* self)
{
	return G_STRUCT_MEMBER_P (self, PCDaemonUserConfig_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../src/daemon/UserConfig.vala"
	return self ? g_object_ref (self) : NULL;
#line 173 "UserConfig.c"
}

PCDaemonUserConfig*
pc_daemon_user_config_get_for_username (const gchar* username,
                                        gboolean create)
{
	GList* _tmp0_;
	PCDaemonUserConfig* result;
#line 29 "../src/daemon/UserConfig.vala"
	g_return_val_if_fail (username != NULL, NULL);
#line 30 "../src/daemon/UserConfig.vala"
	_tmp0_ = pc_daemon_user_config_config_list;
#line 186 "UserConfig.c"
	{
		GList* config_collection = NULL;
		GList* config_it = NULL;
#line 30 "../src/daemon/UserConfig.vala"
		config_collection = _tmp0_;
#line 30 "../src/daemon/UserConfig.vala"
		for (config_it = config_collection; config_it != NULL; config_it = config_it->next) {
#line 194 "UserConfig.c"
			PCDaemonUserConfig* _tmp1_;
			PCDaemonUserConfig* config = NULL;
#line 30 "../src/daemon/UserConfig.vala"
			_tmp1_ = _g_object_ref0 ((PCDaemonUserConfig*) config_it->data);
#line 30 "../src/daemon/UserConfig.vala"
			config = _tmp1_;
#line 201 "UserConfig.c"
			{
				PCDaemonUserConfig* _tmp2_;
				const gchar* _tmp3_;
#line 31 "../src/daemon/UserConfig.vala"
				_tmp2_ = config;
#line 31 "../src/daemon/UserConfig.vala"
				_tmp3_ = _tmp2_->priv->_username;
#line 31 "../src/daemon/UserConfig.vala"
				if (g_strcmp0 (_tmp3_, username) == 0) {
#line 32 "../src/daemon/UserConfig.vala"
					result = config;
#line 32 "../src/daemon/UserConfig.vala"
					return result;
#line 215 "UserConfig.c"
				}
#line 30 "../src/daemon/UserConfig.vala"
				_g_object_unref0 (config);
#line 219 "UserConfig.c"
			}
		}
	}
#line 36 "../src/daemon/UserConfig.vala"
	if (create) {
#line 225 "UserConfig.c"
		PCDaemonUserConfig* _tmp4_;
#line 37 "../src/daemon/UserConfig.vala"
		_tmp4_ = pc_daemon_user_config_create_for_username (username);
#line 37 "../src/daemon/UserConfig.vala"
		result = _tmp4_;
#line 37 "../src/daemon/UserConfig.vala"
		return result;
#line 233 "UserConfig.c"
	}
#line 40 "../src/daemon/UserConfig.vala"
	result = NULL;
#line 40 "../src/daemon/UserConfig.vala"
	return result;
#line 239 "UserConfig.c"
}

GList*
pc_daemon_user_config_get_all (void)
{
	GList* _tmp0_;
	GList* _tmp1_;
	GList* result;
#line 44 "../src/daemon/UserConfig.vala"
	_tmp0_ = pc_daemon_user_config_config_list;
#line 44 "../src/daemon/UserConfig.vala"
	_tmp1_ = g_list_copy (_tmp0_);
#line 44 "../src/daemon/UserConfig.vala"
	result = _tmp1_;
#line 44 "../src/daemon/UserConfig.vala"
	return result;
#line 256 "UserConfig.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 48 "../src/daemon/UserConfig.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 264 "UserConfig.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 48 "../src/daemon/UserConfig.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 272 "UserConfig.c"
}

void
pc_daemon_user_config_init (void)
{
	GKeyFile* _tmp0_;
	GKeyFile* _tmp1_;
	GKeyFile* _tmp7_;
	gsize _tmp8_ = 0;
	gchar** _tmp9_;
	GError* _inner_error0_ = NULL;
#line 48 "../src/daemon/UserConfig.vala"
	(pc_daemon_user_config_config_list == NULL) ? NULL : (pc_daemon_user_config_config_list = (_g_list_free__g_object_unref0_ (pc_daemon_user_config_config_list), NULL));
#line 48 "../src/daemon/UserConfig.vala"
	pc_daemon_user_config_config_list = NULL;
#line 50 "../src/daemon/UserConfig.vala"
	_tmp0_ = g_key_file_new ();
#line 50 "../src/daemon/UserConfig.vala"
	_g_key_file_unref0 (pc_daemon_user_config_key);
#line 50 "../src/daemon/UserConfig.vala"
	pc_daemon_user_config_key = _tmp0_;
#line 51 "../src/daemon/UserConfig.vala"
	_tmp1_ = pc_daemon_user_config_key;
#line 51 "../src/daemon/UserConfig.vala"
	g_key_file_set_list_separator (_tmp1_, ';');
#line 53 "../src/daemon/UserConfig.vala"
	if (!pc_daemon_user_config_init_config_file ()) {
#line 54 "../src/daemon/UserConfig.vala"
		return;
#line 302 "UserConfig.c"
	}
	{
		GKeyFile* _tmp2_;
#line 58 "../src/daemon/UserConfig.vala"
		_tmp2_ = pc_daemon_user_config_key;
#line 58 "../src/daemon/UserConfig.vala"
		g_key_file_load_from_file (_tmp2_, PC_CONSTANTS_DAEMON_CONF_FILE, G_KEY_FILE_KEEP_COMMENTS | G_KEY_FILE_KEEP_TRANSLATIONS, &_inner_error0_);
#line 58 "../src/daemon/UserConfig.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 58 "../src/daemon/UserConfig.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 314 "UserConfig.c"
				goto __catch0_g_key_file_error;
			}
#line 58 "../src/daemon/UserConfig.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 319 "UserConfig.c"
				goto __catch0_g_file_error;
			}
#line 58 "../src/daemon/UserConfig.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 58 "../src/daemon/UserConfig.vala"
			g_clear_error (&_inner_error0_);
#line 58 "../src/daemon/UserConfig.vala"
			return;
#line 328 "UserConfig.c"
		}
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 57 "../src/daemon/UserConfig.vala"
		e = _inner_error0_;
#line 57 "../src/daemon/UserConfig.vala"
		_inner_error0_ = NULL;
#line 62 "../src/daemon/UserConfig.vala"
		_tmp3_ = e;
#line 62 "../src/daemon/UserConfig.vala"
		_tmp4_ = _tmp3_->message;
#line 62 "../src/daemon/UserConfig.vala"
		g_warning ("UserConfig.vala:62: %s", _tmp4_);
#line 57 "../src/daemon/UserConfig.vala"
		_g_error_free0 (e);
#line 349 "UserConfig.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 57 "../src/daemon/UserConfig.vala"
		e = _inner_error0_;
#line 57 "../src/daemon/UserConfig.vala"
		_inner_error0_ = NULL;
#line 64 "../src/daemon/UserConfig.vala"
		_tmp5_ = e;
#line 64 "../src/daemon/UserConfig.vala"
		_tmp6_ = _tmp5_->message;
#line 64 "../src/daemon/UserConfig.vala"
		g_warning ("UserConfig.vala:64: %s", _tmp6_);
#line 57 "../src/daemon/UserConfig.vala"
		_g_error_free0 (e);
#line 369 "UserConfig.c"
	}
	__finally0:
#line 57 "../src/daemon/UserConfig.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 57 "../src/daemon/UserConfig.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 57 "../src/daemon/UserConfig.vala"
		g_clear_error (&_inner_error0_);
#line 57 "../src/daemon/UserConfig.vala"
		return;
#line 380 "UserConfig.c"
	}
#line 67 "../src/daemon/UserConfig.vala"
	_tmp7_ = pc_daemon_user_config_key;
#line 67 "../src/daemon/UserConfig.vala"
	_tmp9_ = g_key_file_get_groups (_tmp7_, &_tmp8_);
#line 386 "UserConfig.c"
	{
		gchar** username_collection = NULL;
		gint username_collection_length1 = 0;
		gint _username_collection_size_ = 0;
		gint username_it = 0;
#line 67 "../src/daemon/UserConfig.vala"
		username_collection = _tmp9_;
#line 67 "../src/daemon/UserConfig.vala"
		username_collection_length1 = _tmp8_;
#line 67 "../src/daemon/UserConfig.vala"
		for (username_it = 0; username_it < username_collection_length1; username_it = username_it + 1) {
#line 398 "UserConfig.c"
			gchar* _tmp10_;
			gchar* username = NULL;
#line 67 "../src/daemon/UserConfig.vala"
			_tmp10_ = g_strdup (username_collection[username_it]);
#line 67 "../src/daemon/UserConfig.vala"
			username = _tmp10_;
#line 405 "UserConfig.c"
			{
				PCDaemonUserConfig* user_config = NULL;
				const gchar* _tmp11_;
				PCDaemonUserConfig* _tmp12_;
				PCDaemonUserConfig* _tmp13_;
				PCDaemonUserConfig* _tmp14_;
#line 68 "../src/daemon/UserConfig.vala"
				_tmp11_ = username;
#line 68 "../src/daemon/UserConfig.vala"
				_tmp12_ = pc_daemon_user_config_new (_tmp11_);
#line 68 "../src/daemon/UserConfig.vala"
				user_config = _tmp12_;
#line 69 "../src/daemon/UserConfig.vala"
				_tmp13_ = user_config;
#line 69 "../src/daemon/UserConfig.vala"
				_tmp14_ = _g_object_ref0 (_tmp13_);
#line 69 "../src/daemon/UserConfig.vala"
				pc_daemon_user_config_config_list = g_list_append (pc_daemon_user_config_config_list, _tmp14_);
#line 67 "../src/daemon/UserConfig.vala"
				_g_object_unref0 (user_config);
#line 67 "../src/daemon/UserConfig.vala"
				_g_free0 (username);
#line 428 "UserConfig.c"
			}
		}
#line 67 "../src/daemon/UserConfig.vala"
		username_collection = (_vala_array_free (username_collection, username_collection_length1, (GDestroyNotify) g_free), NULL);
#line 433 "UserConfig.c"
	}
}

static gboolean
pc_daemon_user_config_init_config_file (void)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gboolean result;
#line 74 "../src/daemon/UserConfig.vala"
	_tmp0_ = g_file_new_for_path (PC_CONSTANTS_DAEMON_CONF_FILE);
#line 74 "../src/daemon/UserConfig.vala"
	file = _tmp0_;
#line 75 "../src/daemon/UserConfig.vala"
	_tmp1_ = file;
#line 75 "../src/daemon/UserConfig.vala"
	if (!g_file_query_exists (_tmp1_, NULL)) {
#line 452 "UserConfig.c"
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 76 "../src/daemon/UserConfig.vala"
		_tmp2_ = file;
#line 76 "../src/daemon/UserConfig.vala"
		_tmp3_ = g_file_get_path (_tmp2_);
#line 76 "../src/daemon/UserConfig.vala"
		_tmp4_ = _tmp3_;
#line 76 "../src/daemon/UserConfig.vala"
		_tmp5_ = g_strdup_printf ("Could not find daemon config file: %s does not exist", _tmp4_);
#line 76 "../src/daemon/UserConfig.vala"
		_tmp6_ = _tmp5_;
#line 76 "../src/daemon/UserConfig.vala"
		g_critical ("UserConfig.vala:76: %s", _tmp6_);
#line 76 "../src/daemon/UserConfig.vala"
		_g_free0 (_tmp6_);
#line 76 "../src/daemon/UserConfig.vala"
		_g_free0 (_tmp4_);
#line 77 "../src/daemon/UserConfig.vala"
		result = FALSE;
#line 77 "../src/daemon/UserConfig.vala"
		_g_object_unref0 (file);
#line 77 "../src/daemon/UserConfig.vala"
		return result;
#line 480 "UserConfig.c"
	}
#line 80 "../src/daemon/UserConfig.vala"
	result = TRUE;
#line 80 "../src/daemon/UserConfig.vala"
	_g_object_unref0 (file);
#line 80 "../src/daemon/UserConfig.vala"
	return result;
#line 488 "UserConfig.c"
}

static PCDaemonUserConfig*
pc_daemon_user_config_create_for_username (const gchar* username)
{
	ActUser* user = NULL;
	ActUserManager* _tmp0_;
	ActUser* _tmp1_;
	ActUser* _tmp2_;
	ActUser* _tmp3_;
	PCDaemonUserConfig* config = NULL;
	PCDaemonUserConfig* _tmp4_;
	PCDaemonUserConfig* _tmp5_;
	PCDaemonUserConfig* _tmp6_;
	PCDaemonUserConfig* _tmp7_;
	PCDaemonUserConfig* result;
#line 83 "../src/daemon/UserConfig.vala"
	g_return_val_if_fail (username != NULL, NULL);
#line 84 "../src/daemon/UserConfig.vala"
	_tmp0_ = pc_utils_get_usermanager ();
#line 84 "../src/daemon/UserConfig.vala"
	_tmp1_ = act_user_manager_get_user (_tmp0_, username);
#line 84 "../src/daemon/UserConfig.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 84 "../src/daemon/UserConfig.vala"
	user = _tmp2_;
#line 85 "../src/daemon/UserConfig.vala"
	_tmp3_ = user;
#line 85 "../src/daemon/UserConfig.vala"
	if (_tmp3_ == NULL) {
#line 86 "../src/daemon/UserConfig.vala"
		result = NULL;
#line 86 "../src/daemon/UserConfig.vala"
		_g_object_unref0 (user);
#line 86 "../src/daemon/UserConfig.vala"
		return result;
#line 525 "UserConfig.c"
	}
#line 89 "../src/daemon/UserConfig.vala"
	_tmp4_ = pc_daemon_user_config_new (username);
#line 89 "../src/daemon/UserConfig.vala"
	config = _tmp4_;
#line 90 "../src/daemon/UserConfig.vala"
	_tmp5_ = config;
#line 90 "../src/daemon/UserConfig.vala"
	pc_daemon_user_config_set_active (_tmp5_, FALSE);
#line 91 "../src/daemon/UserConfig.vala"
	_tmp6_ = config;
#line 91 "../src/daemon/UserConfig.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 91 "../src/daemon/UserConfig.vala"
	pc_daemon_user_config_config_list = g_list_append (pc_daemon_user_config_config_list, _tmp7_);
#line 92 "../src/daemon/UserConfig.vala"
	result = config;
#line 92 "../src/daemon/UserConfig.vala"
	_g_object_unref0 (user);
#line 92 "../src/daemon/UserConfig.vala"
	return result;
#line 547 "UserConfig.c"
}

static PCDaemonUserConfig*
pc_daemon_user_config_construct (GType object_type,
                                 const gchar* username)
{
	PCDaemonUserConfig * self = NULL;
#line 95 "../src/daemon/UserConfig.vala"
	g_return_val_if_fail (username != NULL, NULL);
#line 95 "../src/daemon/UserConfig.vala"
	self = (PCDaemonUserConfig*) g_object_new (object_type, NULL);
#line 96 "../src/daemon/UserConfig.vala"
	pc_daemon_user_config_set_username (self, username);
#line 95 "../src/daemon/UserConfig.vala"
	return self;
#line 563 "UserConfig.c"
}

static PCDaemonUserConfig*
pc_daemon_user_config_new (const gchar* username)
{
#line 95 "../src/daemon/UserConfig.vala"
	return pc_daemon_user_config_construct (PC_DAEMON_TYPE_USER_CONFIG, username);
#line 571 "UserConfig.c"
}

static void
pc_daemon_user_config_save (PCDaemonUserConfig* self)
{
	PCDaemonServer* _tmp3_;
	PCDaemonServer* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 163 "../src/daemon/UserConfig.vala"
	g_return_if_fail (self != NULL);
#line 582 "UserConfig.c"
	{
		GKeyFile* _tmp0_;
#line 165 "../src/daemon/UserConfig.vala"
		_tmp0_ = pc_daemon_user_config_key;
#line 165 "../src/daemon/UserConfig.vala"
		g_key_file_save_to_file (_tmp0_, PC_CONSTANTS_DAEMON_CONF_FILE, &_inner_error0_);
#line 165 "../src/daemon/UserConfig.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 165 "../src/daemon/UserConfig.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 593 "UserConfig.c"
				goto __catch0_g_file_error;
			}
#line 165 "../src/daemon/UserConfig.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 165 "../src/daemon/UserConfig.vala"
			g_clear_error (&_inner_error0_);
#line 165 "../src/daemon/UserConfig.vala"
			return;
#line 602 "UserConfig.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 164 "../src/daemon/UserConfig.vala"
		e = _inner_error0_;
#line 164 "../src/daemon/UserConfig.vala"
		_inner_error0_ = NULL;
#line 167 "../src/daemon/UserConfig.vala"
		_tmp1_ = e;
#line 167 "../src/daemon/UserConfig.vala"
		_tmp2_ = _tmp1_->message;
#line 167 "../src/daemon/UserConfig.vala"
		g_warning ("UserConfig.vala:167: %s", _tmp2_);
#line 168 "../src/daemon/UserConfig.vala"
		_g_error_free0 (e);
#line 168 "../src/daemon/UserConfig.vala"
		return;
#line 625 "UserConfig.c"
	}
	__finally0:
#line 164 "../src/daemon/UserConfig.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 164 "../src/daemon/UserConfig.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 164 "../src/daemon/UserConfig.vala"
		g_clear_error (&_inner_error0_);
#line 164 "../src/daemon/UserConfig.vala"
		return;
#line 636 "UserConfig.c"
	}
#line 171 "../src/daemon/UserConfig.vala"
	_tmp3_ = pc_daemon_server_get_default ();
#line 171 "../src/daemon/UserConfig.vala"
	_tmp4_ = _tmp3_;
#line 171 "../src/daemon/UserConfig.vala"
	g_signal_emit_by_name (_tmp4_, "config-changed");
#line 171 "../src/daemon/UserConfig.vala"
	_g_object_unref0 (_tmp4_);
#line 646 "UserConfig.c"
}

const gchar*
pc_daemon_user_config_get_username (PCDaemonUserConfig* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 24 "../src/daemon/UserConfig.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/daemon/UserConfig.vala"
	_tmp0_ = self->priv->_username;
#line 24 "../src/daemon/UserConfig.vala"
	result = _tmp0_;
#line 24 "../src/daemon/UserConfig.vala"
	return result;
#line 662 "UserConfig.c"
}

void
pc_daemon_user_config_set_username (PCDaemonUserConfig* self,
                                    const gchar* value)
{
	gchar* old_value;
#line 24 "../src/daemon/UserConfig.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/daemon/UserConfig.vala"
	old_value = pc_daemon_user_config_get_username (self);
#line 24 "../src/daemon/UserConfig.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 676 "UserConfig.c"
		gchar* _tmp0_;
#line 24 "../src/daemon/UserConfig.vala"
		_tmp0_ = g_strdup (value);
#line 24 "../src/daemon/UserConfig.vala"
		_g_free0 (self->priv->_username);
#line 24 "../src/daemon/UserConfig.vala"
		self->priv->_username = _tmp0_;
#line 24 "../src/daemon/UserConfig.vala"
		g_object_notify_by_pspec ((GObject *) self, pc_daemon_user_config_properties[PC_DAEMON_USER_CONFIG_USERNAME_PROPERTY]);
#line 686 "UserConfig.c"
	}
}

gboolean
pc_daemon_user_config_get_active (PCDaemonUserConfig* self)
{
	gboolean result;
	GError* _inner_error0_ = NULL;
#line 100 "../src/daemon/UserConfig.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 697 "UserConfig.c"
	{
		gboolean _tmp0_ = FALSE;
		GKeyFile* _tmp1_;
		const gchar* _tmp2_;
#line 102 "../src/daemon/UserConfig.vala"
		_tmp1_ = pc_daemon_user_config_key;
#line 102 "../src/daemon/UserConfig.vala"
		_tmp2_ = self->priv->_username;
#line 102 "../src/daemon/UserConfig.vala"
		_tmp0_ = g_key_file_get_boolean (_tmp1_, _tmp2_, PC_CONSTANTS_DAEMON_KEY_ACTIVE, &_inner_error0_);
#line 102 "../src/daemon/UserConfig.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 710 "UserConfig.c"
			gboolean _tmp3_ = FALSE;
#line 102 "../src/daemon/UserConfig.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 714 "UserConfig.c"
				goto __catch0_g_key_file_error;
			}
#line 102 "../src/daemon/UserConfig.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 102 "../src/daemon/UserConfig.vala"
			g_clear_error (&_inner_error0_);
#line 102 "../src/daemon/UserConfig.vala"
			return _tmp3_;
#line 723 "UserConfig.c"
		}
#line 102 "../src/daemon/UserConfig.vala"
		result = _tmp0_;
#line 102 "../src/daemon/UserConfig.vala"
		return result;
#line 729 "UserConfig.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 101 "../src/daemon/UserConfig.vala"
		e = _inner_error0_;
#line 101 "../src/daemon/UserConfig.vala"
		_inner_error0_ = NULL;
#line 104 "../src/daemon/UserConfig.vala"
		_tmp4_ = e;
#line 104 "../src/daemon/UserConfig.vala"
		_tmp5_ = _tmp4_->message;
#line 104 "../src/daemon/UserConfig.vala"
		g_critical ("UserConfig.vala:104: %s", _tmp5_);
#line 101 "../src/daemon/UserConfig.vala"
		_g_error_free0 (e);
#line 749 "UserConfig.c"
	}
	__finally0:
#line 101 "../src/daemon/UserConfig.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 754 "UserConfig.c"
		gboolean _tmp6_ = FALSE;
#line 101 "../src/daemon/UserConfig.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 101 "../src/daemon/UserConfig.vala"
		g_clear_error (&_inner_error0_);
#line 101 "../src/daemon/UserConfig.vala"
		return _tmp6_;
#line 762 "UserConfig.c"
	}
#line 107 "../src/daemon/UserConfig.vala"
	result = FALSE;
#line 107 "../src/daemon/UserConfig.vala"
	return result;
#line 768 "UserConfig.c"
}

void
pc_daemon_user_config_set_active (PCDaemonUserConfig* self,
                                  gboolean value)
{
	GKeyFile* _tmp0_;
	const gchar* _tmp1_;
#line 109 "../src/daemon/UserConfig.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/daemon/UserConfig.vala"
	_tmp0_ = pc_daemon_user_config_key;
#line 110 "../src/daemon/UserConfig.vala"
	_tmp1_ = self->priv->_username;
#line 110 "../src/daemon/UserConfig.vala"
	g_key_file_set_boolean (_tmp0_, _tmp1_, PC_CONSTANTS_DAEMON_KEY_ACTIVE, value);
#line 111 "../src/daemon/UserConfig.vala"
	pc_daemon_user_config_save (self);
#line 109 "../src/daemon/UserConfig.vala"
	g_object_notify_by_pspec ((GObject *) self, pc_daemon_user_config_properties[PC_DAEMON_USER_CONFIG_ACTIVE_PROPERTY]);
#line 789 "UserConfig.c"
}

gchar**
pc_daemon_user_config_get_targets (PCDaemonUserConfig* self,
                                   gint* result_length1)
{
	gchar** result;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	GError* _inner_error0_ = NULL;
#line 116 "../src/daemon/UserConfig.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 803 "UserConfig.c"
	{
		gchar** _tmp0_ = NULL;
		GKeyFile* _tmp1_;
		const gchar* _tmp2_;
		gsize _tmp3_ = 0;
		gchar** _tmp4_;
		gint _tmp0__length1;
		gint __tmp0__size_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		gchar** _tmp6_;
		gint _tmp6__length1;
#line 118 "../src/daemon/UserConfig.vala"
		_tmp1_ = pc_daemon_user_config_key;
#line 118 "../src/daemon/UserConfig.vala"
		_tmp2_ = self->priv->_username;
#line 118 "../src/daemon/UserConfig.vala"
		_tmp4_ = g_key_file_get_string_list (_tmp1_, _tmp2_, PC_CONSTANTS_DAEMON_KEY_TARGETS, &_tmp3_, &_inner_error0_);
#line 118 "../src/daemon/UserConfig.vala"
		_tmp0_ = _tmp4_;
#line 118 "../src/daemon/UserConfig.vala"
		_tmp0__length1 = _tmp3_;
#line 118 "../src/daemon/UserConfig.vala"
		__tmp0__size_ = _tmp0__length1;
#line 118 "../src/daemon/UserConfig.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 118 "../src/daemon/UserConfig.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 832 "UserConfig.c"
				goto __catch0_g_key_file_error;
			}
#line 118 "../src/daemon/UserConfig.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 118 "../src/daemon/UserConfig.vala"
			g_clear_error (&_inner_error0_);
#line 118 "../src/daemon/UserConfig.vala"
			return NULL;
#line 841 "UserConfig.c"
		}
#line 118 "../src/daemon/UserConfig.vala"
		_tmp5_ = _tmp0_;
#line 118 "../src/daemon/UserConfig.vala"
		_tmp5__length1 = _tmp0__length1;
#line 118 "../src/daemon/UserConfig.vala"
		_tmp0_ = NULL;
#line 118 "../src/daemon/UserConfig.vala"
		_tmp0__length1 = 0;
#line 118 "../src/daemon/UserConfig.vala"
		_tmp6_ = _tmp5_;
#line 118 "../src/daemon/UserConfig.vala"
		_tmp6__length1 = _tmp5__length1;
#line 118 "../src/daemon/UserConfig.vala"
		if (result_length1) {
#line 118 "../src/daemon/UserConfig.vala"
			*result_length1 = _tmp6__length1;
#line 859 "UserConfig.c"
		}
#line 118 "../src/daemon/UserConfig.vala"
		result = _tmp6_;
#line 118 "../src/daemon/UserConfig.vala"
		_tmp0_ = (_vala_array_free (_tmp0_, _tmp0__length1, (GDestroyNotify) g_free), NULL);
#line 118 "../src/daemon/UserConfig.vala"
		return result;
#line 867 "UserConfig.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 117 "../src/daemon/UserConfig.vala"
		e = _inner_error0_;
#line 117 "../src/daemon/UserConfig.vala"
		_inner_error0_ = NULL;
#line 120 "../src/daemon/UserConfig.vala"
		_tmp7_ = e;
#line 120 "../src/daemon/UserConfig.vala"
		_tmp8_ = _tmp7_->message;
#line 120 "../src/daemon/UserConfig.vala"
		g_critical ("UserConfig.vala:120: %s", _tmp8_);
#line 117 "../src/daemon/UserConfig.vala"
		_g_error_free0 (e);
#line 887 "UserConfig.c"
	}
	__finally0:
#line 117 "../src/daemon/UserConfig.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 117 "../src/daemon/UserConfig.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 117 "../src/daemon/UserConfig.vala"
		g_clear_error (&_inner_error0_);
#line 117 "../src/daemon/UserConfig.vala"
		return NULL;
#line 898 "UserConfig.c"
	}
#line 123 "../src/daemon/UserConfig.vala"
	_tmp9_ = g_new0 (gchar*, 0 + 1);
#line 123 "../src/daemon/UserConfig.vala"
	_tmp10_ = _tmp9_;
#line 123 "../src/daemon/UserConfig.vala"
	_tmp10__length1 = 0;
#line 123 "../src/daemon/UserConfig.vala"
	if (result_length1) {
#line 123 "../src/daemon/UserConfig.vala"
		*result_length1 = _tmp10__length1;
#line 910 "UserConfig.c"
	}
#line 123 "../src/daemon/UserConfig.vala"
	result = _tmp10_;
#line 123 "../src/daemon/UserConfig.vala"
	return result;
#line 916 "UserConfig.c"
}

void
pc_daemon_user_config_set_targets (PCDaemonUserConfig* self,
                                   gchar** value,
                                   gint value_length1)
{
	GKeyFile* _tmp0_;
	const gchar* _tmp1_;
#line 125 "../src/daemon/UserConfig.vala"
	g_return_if_fail (self != NULL);
#line 126 "../src/daemon/UserConfig.vala"
	_tmp0_ = pc_daemon_user_config_key;
#line 126 "../src/daemon/UserConfig.vala"
	_tmp1_ = self->priv->_username;
#line 126 "../src/daemon/UserConfig.vala"
	g_key_file_set_string_list (_tmp0_, _tmp1_, PC_CONSTANTS_DAEMON_KEY_TARGETS, (const gchar* const*) value, (gint) value_length1);
#line 127 "../src/daemon/UserConfig.vala"
	pc_daemon_user_config_save (self);
#line 125 "../src/daemon/UserConfig.vala"
	g_object_notify_by_pspec ((GObject *) self, pc_daemon_user_config_properties[PC_DAEMON_USER_CONFIG_TARGETS_PROPERTY]);
#line 938 "UserConfig.c"
}

gchar**
pc_daemon_user_config_get_block_urls (PCDaemonUserConfig* self,
                                      gint* result_length1)
{
	gchar** result;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	GError* _inner_error0_ = NULL;
#line 132 "../src/daemon/UserConfig.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 952 "UserConfig.c"
	{
		gchar** _tmp0_ = NULL;
		GKeyFile* _tmp1_;
		const gchar* _tmp2_;
		gsize _tmp3_ = 0;
		gchar** _tmp4_;
		gint _tmp0__length1;
		gint __tmp0__size_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		gchar** _tmp6_;
		gint _tmp6__length1;
#line 134 "../src/daemon/UserConfig.vala"
		_tmp1_ = pc_daemon_user_config_key;
#line 134 "../src/daemon/UserConfig.vala"
		_tmp2_ = self->priv->_username;
#line 134 "../src/daemon/UserConfig.vala"
		_tmp4_ = g_key_file_get_string_list (_tmp1_, _tmp2_, PC_CONSTANTS_DAEMON_KEY_BLOCK_URLS, &_tmp3_, &_inner_error0_);
#line 134 "../src/daemon/UserConfig.vala"
		_tmp0_ = _tmp4_;
#line 134 "../src/daemon/UserConfig.vala"
		_tmp0__length1 = _tmp3_;
#line 134 "../src/daemon/UserConfig.vala"
		__tmp0__size_ = _tmp0__length1;
#line 134 "../src/daemon/UserConfig.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 134 "../src/daemon/UserConfig.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 981 "UserConfig.c"
				goto __catch0_g_key_file_error;
			}
#line 134 "../src/daemon/UserConfig.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 134 "../src/daemon/UserConfig.vala"
			g_clear_error (&_inner_error0_);
#line 134 "../src/daemon/UserConfig.vala"
			return NULL;
#line 990 "UserConfig.c"
		}
#line 134 "../src/daemon/UserConfig.vala"
		_tmp5_ = _tmp0_;
#line 134 "../src/daemon/UserConfig.vala"
		_tmp5__length1 = _tmp0__length1;
#line 134 "../src/daemon/UserConfig.vala"
		_tmp0_ = NULL;
#line 134 "../src/daemon/UserConfig.vala"
		_tmp0__length1 = 0;
#line 134 "../src/daemon/UserConfig.vala"
		_tmp6_ = _tmp5_;
#line 134 "../src/daemon/UserConfig.vala"
		_tmp6__length1 = _tmp5__length1;
#line 134 "../src/daemon/UserConfig.vala"
		if (result_length1) {
#line 134 "../src/daemon/UserConfig.vala"
			*result_length1 = _tmp6__length1;
#line 1008 "UserConfig.c"
		}
#line 134 "../src/daemon/UserConfig.vala"
		result = _tmp6_;
#line 134 "../src/daemon/UserConfig.vala"
		_tmp0_ = (_vala_array_free (_tmp0_, _tmp0__length1, (GDestroyNotify) g_free), NULL);
#line 134 "../src/daemon/UserConfig.vala"
		return result;
#line 1016 "UserConfig.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 133 "../src/daemon/UserConfig.vala"
		e = _inner_error0_;
#line 133 "../src/daemon/UserConfig.vala"
		_inner_error0_ = NULL;
#line 136 "../src/daemon/UserConfig.vala"
		_tmp7_ = e;
#line 136 "../src/daemon/UserConfig.vala"
		_tmp8_ = _tmp7_->message;
#line 136 "../src/daemon/UserConfig.vala"
		g_critical ("UserConfig.vala:136: %s", _tmp8_);
#line 133 "../src/daemon/UserConfig.vala"
		_g_error_free0 (e);
#line 1036 "UserConfig.c"
	}
	__finally0:
#line 133 "../src/daemon/UserConfig.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 133 "../src/daemon/UserConfig.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 133 "../src/daemon/UserConfig.vala"
		g_clear_error (&_inner_error0_);
#line 133 "../src/daemon/UserConfig.vala"
		return NULL;
#line 1047 "UserConfig.c"
	}
#line 139 "../src/daemon/UserConfig.vala"
	_tmp9_ = g_new0 (gchar*, 0 + 1);
#line 139 "../src/daemon/UserConfig.vala"
	_tmp10_ = _tmp9_;
#line 139 "../src/daemon/UserConfig.vala"
	_tmp10__length1 = 0;
#line 139 "../src/daemon/UserConfig.vala"
	if (result_length1) {
#line 139 "../src/daemon/UserConfig.vala"
		*result_length1 = _tmp10__length1;
#line 1059 "UserConfig.c"
	}
#line 139 "../src/daemon/UserConfig.vala"
	result = _tmp10_;
#line 139 "../src/daemon/UserConfig.vala"
	return result;
#line 1065 "UserConfig.c"
}

void
pc_daemon_user_config_set_block_urls (PCDaemonUserConfig* self,
                                      gchar** value,
                                      gint value_length1)
{
	GKeyFile* _tmp0_;
	const gchar* _tmp1_;
#line 141 "../src/daemon/UserConfig.vala"
	g_return_if_fail (self != NULL);
#line 142 "../src/daemon/UserConfig.vala"
	_tmp0_ = pc_daemon_user_config_key;
#line 142 "../src/daemon/UserConfig.vala"
	_tmp1_ = self->priv->_username;
#line 142 "../src/daemon/UserConfig.vala"
	g_key_file_set_string_list (_tmp0_, _tmp1_, PC_CONSTANTS_DAEMON_KEY_BLOCK_URLS, (const gchar* const*) value, (gint) value_length1);
#line 143 "../src/daemon/UserConfig.vala"
	pc_daemon_user_config_save (self);
#line 141 "../src/daemon/UserConfig.vala"
	g_object_notify_by_pspec ((GObject *) self, pc_daemon_user_config_properties[PC_DAEMON_USER_CONFIG_BLOCK_URLS_PROPERTY]);
#line 1087 "UserConfig.c"
}

gboolean
pc_daemon_user_config_get_admin (PCDaemonUserConfig* self)
{
	gboolean result;
	GError* _inner_error0_ = NULL;
#line 148 "../src/daemon/UserConfig.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1097 "UserConfig.c"
	{
		gboolean _tmp0_ = FALSE;
		GKeyFile* _tmp1_;
		const gchar* _tmp2_;
#line 150 "../src/daemon/UserConfig.vala"
		_tmp1_ = pc_daemon_user_config_key;
#line 150 "../src/daemon/UserConfig.vala"
		_tmp2_ = self->priv->_username;
#line 150 "../src/daemon/UserConfig.vala"
		_tmp0_ = g_key_file_get_boolean (_tmp1_, _tmp2_, PC_CONSTANTS_DAEMON_KEY_ADMIN, &_inner_error0_);
#line 150 "../src/daemon/UserConfig.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1110 "UserConfig.c"
			gboolean _tmp3_ = FALSE;
#line 150 "../src/daemon/UserConfig.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1114 "UserConfig.c"
				goto __catch0_g_key_file_error;
			}
#line 150 "../src/daemon/UserConfig.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 150 "../src/daemon/UserConfig.vala"
			g_clear_error (&_inner_error0_);
#line 150 "../src/daemon/UserConfig.vala"
			return _tmp3_;
#line 1123 "UserConfig.c"
		}
#line 150 "../src/daemon/UserConfig.vala"
		result = _tmp0_;
#line 150 "../src/daemon/UserConfig.vala"
		return result;
#line 1129 "UserConfig.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 149 "../src/daemon/UserConfig.vala"
		e = _inner_error0_;
#line 149 "../src/daemon/UserConfig.vala"
		_inner_error0_ = NULL;
#line 152 "../src/daemon/UserConfig.vala"
		_tmp4_ = e;
#line 152 "../src/daemon/UserConfig.vala"
		_tmp5_ = _tmp4_->message;
#line 152 "../src/daemon/UserConfig.vala"
		g_critical ("UserConfig.vala:152: %s", _tmp5_);
#line 149 "../src/daemon/UserConfig.vala"
		_g_error_free0 (e);
#line 1149 "UserConfig.c"
	}
	__finally0:
#line 149 "../src/daemon/UserConfig.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1154 "UserConfig.c"
		gboolean _tmp6_ = FALSE;
#line 149 "../src/daemon/UserConfig.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 149 "../src/daemon/UserConfig.vala"
		g_clear_error (&_inner_error0_);
#line 149 "../src/daemon/UserConfig.vala"
		return _tmp6_;
#line 1162 "UserConfig.c"
	}
#line 155 "../src/daemon/UserConfig.vala"
	result = FALSE;
#line 155 "../src/daemon/UserConfig.vala"
	return result;
#line 1168 "UserConfig.c"
}

void
pc_daemon_user_config_set_admin (PCDaemonUserConfig* self,
                                 gboolean value)
{
	GKeyFile* _tmp0_;
	const gchar* _tmp1_;
#line 157 "../src/daemon/UserConfig.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/daemon/UserConfig.vala"
	_tmp0_ = pc_daemon_user_config_key;
#line 158 "../src/daemon/UserConfig.vala"
	_tmp1_ = self->priv->_username;
#line 158 "../src/daemon/UserConfig.vala"
	g_key_file_set_boolean (_tmp0_, _tmp1_, PC_CONSTANTS_DAEMON_KEY_ADMIN, value);
#line 159 "../src/daemon/UserConfig.vala"
	pc_daemon_user_config_save (self);
#line 157 "../src/daemon/UserConfig.vala"
	g_object_notify_by_pspec ((GObject *) self, pc_daemon_user_config_properties[PC_DAEMON_USER_CONFIG_ADMIN_PROPERTY]);
#line 1189 "UserConfig.c"
}

static void
pc_daemon_user_config_class_init (PCDaemonUserConfigClass * klass,
                                  gpointer klass_data)
{
#line 23 "../src/daemon/UserConfig.vala"
	pc_daemon_user_config_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/daemon/UserConfig.vala"
	g_type_class_adjust_private_offset (klass, &PCDaemonUserConfig_private_offset);
#line 23 "../src/daemon/UserConfig.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_pc_daemon_user_config_get_property;
#line 23 "../src/daemon/UserConfig.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_pc_daemon_user_config_set_property;
#line 23 "../src/daemon/UserConfig.vala"
	G_OBJECT_CLASS (klass)->finalize = pc_daemon_user_config_finalize;
#line 23 "../src/daemon/UserConfig.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PC_DAEMON_USER_CONFIG_USERNAME_PROPERTY, pc_daemon_user_config_properties[PC_DAEMON_USER_CONFIG_USERNAME_PROPERTY] = g_param_spec_string ("username", "username", "username", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/daemon/UserConfig.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PC_DAEMON_USER_CONFIG_ACTIVE_PROPERTY, pc_daemon_user_config_properties[PC_DAEMON_USER_CONFIG_ACTIVE_PROPERTY] = g_param_spec_boolean ("active", "active", "active", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/daemon/UserConfig.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PC_DAEMON_USER_CONFIG_TARGETS_PROPERTY, pc_daemon_user_config_properties[PC_DAEMON_USER_CONFIG_TARGETS_PROPERTY] = g_param_spec_boxed ("targets", "targets", "targets", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/daemon/UserConfig.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PC_DAEMON_USER_CONFIG_BLOCK_URLS_PROPERTY, pc_daemon_user_config_properties[PC_DAEMON_USER_CONFIG_BLOCK_URLS_PROPERTY] = g_param_spec_boxed ("block-urls", "block-urls", "block-urls", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/daemon/UserConfig.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PC_DAEMON_USER_CONFIG_ADMIN_PROPERTY, pc_daemon_user_config_properties[PC_DAEMON_USER_CONFIG_ADMIN_PROPERTY] = g_param_spec_boolean ("admin", "admin", "admin", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1216 "UserConfig.c"
}

static void
pc_daemon_user_config_instance_init (PCDaemonUserConfig * self,
                                     gpointer klass)
{
#line 23 "../src/daemon/UserConfig.vala"
	self->priv = pc_daemon_user_config_get_instance_private (self);
#line 1225 "UserConfig.c"
}

static void
pc_daemon_user_config_finalize (GObject * obj)
{
	PCDaemonUserConfig * self;
#line 23 "../src/daemon/UserConfig.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PC_DAEMON_TYPE_USER_CONFIG, PCDaemonUserConfig);
#line 24 "../src/daemon/UserConfig.vala"
	_g_free0 (self->priv->_username);
#line 23 "../src/daemon/UserConfig.vala"
	G_OBJECT_CLASS (pc_daemon_user_config_parent_class)->finalize (obj);
#line 1238 "UserConfig.c"
}

static GType
pc_daemon_user_config_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PCDaemonUserConfigClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pc_daemon_user_config_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PCDaemonUserConfig), 0, (GInstanceInitFunc) pc_daemon_user_config_instance_init, NULL };
	GType pc_daemon_user_config_type_id;
	pc_daemon_user_config_type_id = g_type_register_static (G_TYPE_OBJECT, "PCDaemonUserConfig", &g_define_type_info, 0);
	PCDaemonUserConfig_private_offset = g_type_add_instance_private (pc_daemon_user_config_type_id, sizeof (PCDaemonUserConfigPrivate));
	return pc_daemon_user_config_type_id;
}

GType
pc_daemon_user_config_get_type (void)
{
	static volatile gsize pc_daemon_user_config_type_id__once = 0;
	if (g_once_init_enter (&pc_daemon_user_config_type_id__once)) {
		GType pc_daemon_user_config_type_id;
		pc_daemon_user_config_type_id = pc_daemon_user_config_get_type_once ();
		g_once_init_leave (&pc_daemon_user_config_type_id__once, pc_daemon_user_config_type_id);
	}
	return pc_daemon_user_config_type_id__once;
}

static void
_vala_pc_daemon_user_config_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	PCDaemonUserConfig * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PC_DAEMON_TYPE_USER_CONFIG, PCDaemonUserConfig);
#line 23 "../src/daemon/UserConfig.vala"
	switch (property_id) {
#line 23 "../src/daemon/UserConfig.vala"
		case PC_DAEMON_USER_CONFIG_USERNAME_PROPERTY:
#line 23 "../src/daemon/UserConfig.vala"
		g_value_set_string (value, pc_daemon_user_config_get_username (self));
#line 23 "../src/daemon/UserConfig.vala"
		break;
#line 23 "../src/daemon/UserConfig.vala"
		case PC_DAEMON_USER_CONFIG_ACTIVE_PROPERTY:
#line 23 "../src/daemon/UserConfig.vala"
		g_value_set_boolean (value, pc_daemon_user_config_get_active (self));
#line 23 "../src/daemon/UserConfig.vala"
		break;
#line 23 "../src/daemon/UserConfig.vala"
		case PC_DAEMON_USER_CONFIG_TARGETS_PROPERTY:
#line 1287 "UserConfig.c"
		{
			int length;
#line 23 "../src/daemon/UserConfig.vala"
			g_value_take_boxed (value, pc_daemon_user_config_get_targets (self, &length));
#line 1292 "UserConfig.c"
		}
#line 23 "../src/daemon/UserConfig.vala"
		break;
#line 23 "../src/daemon/UserConfig.vala"
		case PC_DAEMON_USER_CONFIG_BLOCK_URLS_PROPERTY:
#line 1298 "UserConfig.c"
		{
			int length;
#line 23 "../src/daemon/UserConfig.vala"
			g_value_take_boxed (value, pc_daemon_user_config_get_block_urls (self, &length));
#line 1303 "UserConfig.c"
		}
#line 23 "../src/daemon/UserConfig.vala"
		break;
#line 23 "../src/daemon/UserConfig.vala"
		case PC_DAEMON_USER_CONFIG_ADMIN_PROPERTY:
#line 23 "../src/daemon/UserConfig.vala"
		g_value_set_boolean (value, pc_daemon_user_config_get_admin (self));
#line 23 "../src/daemon/UserConfig.vala"
		break;
#line 1313 "UserConfig.c"
		default:
#line 23 "../src/daemon/UserConfig.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/daemon/UserConfig.vala"
		break;
#line 1319 "UserConfig.c"
	}
}

static void
_vala_pc_daemon_user_config_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	PCDaemonUserConfig * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PC_DAEMON_TYPE_USER_CONFIG, PCDaemonUserConfig);
#line 23 "../src/daemon/UserConfig.vala"
	switch (property_id) {
#line 23 "../src/daemon/UserConfig.vala"
		case PC_DAEMON_USER_CONFIG_USERNAME_PROPERTY:
#line 23 "../src/daemon/UserConfig.vala"
		pc_daemon_user_config_set_username (self, g_value_get_string (value));
#line 23 "../src/daemon/UserConfig.vala"
		break;
#line 23 "../src/daemon/UserConfig.vala"
		case PC_DAEMON_USER_CONFIG_ACTIVE_PROPERTY:
#line 23 "../src/daemon/UserConfig.vala"
		pc_daemon_user_config_set_active (self, g_value_get_boolean (value));
#line 23 "../src/daemon/UserConfig.vala"
		break;
#line 23 "../src/daemon/UserConfig.vala"
		case PC_DAEMON_USER_CONFIG_TARGETS_PROPERTY:
#line 1347 "UserConfig.c"
		{
			gpointer boxed;
#line 23 "../src/daemon/UserConfig.vala"
			boxed = g_value_get_boxed (value);
#line 23 "../src/daemon/UserConfig.vala"
			pc_daemon_user_config_set_targets (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 1354 "UserConfig.c"
		}
#line 23 "../src/daemon/UserConfig.vala"
		break;
#line 23 "../src/daemon/UserConfig.vala"
		case PC_DAEMON_USER_CONFIG_BLOCK_URLS_PROPERTY:
#line 1360 "UserConfig.c"
		{
			gpointer boxed;
#line 23 "../src/daemon/UserConfig.vala"
			boxed = g_value_get_boxed (value);
#line 23 "../src/daemon/UserConfig.vala"
			pc_daemon_user_config_set_block_urls (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 1367 "UserConfig.c"
		}
#line 23 "../src/daemon/UserConfig.vala"
		break;
#line 23 "../src/daemon/UserConfig.vala"
		case PC_DAEMON_USER_CONFIG_ADMIN_PROPERTY:
#line 23 "../src/daemon/UserConfig.vala"
		pc_daemon_user_config_set_admin (self, g_value_get_boolean (value));
#line 23 "../src/daemon/UserConfig.vala"
		break;
#line 1377 "UserConfig.c"
		default:
#line 23 "../src/daemon/UserConfig.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/daemon/UserConfig.vala"
		break;
#line 1383 "UserConfig.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

