/* Plug.c generated by valac 0.56.14, the Vala compiler
 * generated from Plug.vala, do not modify */

/*
 * Copyright 2019 elementary, Inc. (https://elementary.io)
 *           2015 Adam Bieńkowski (https://launchpad.net/switchboard-plug-parental-controls)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include "parental-controls.h"
#include <switchboard.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gmodule.h>

enum  {
	PC_PLUG_0_PROPERTY,
	PC_PLUG_NUM_PROPERTIES
};
static GParamSpec* pc_plug_properties[PC_PLUG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _PcPlugSearchData PcPlugSearchData;

struct _PCPlugPrivate {
	PCMainBox* main_box;
};

struct _PcPlugSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PCPlug* self;
	gchar* search;
	GeeTreeMap* result;
	GeeTreeMap* search_results;
	GeeTreeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
};

static gint PCPlug_private_offset;
static gpointer pc_plug_parent_class = NULL;

static GtkWidget* pc_plug_real_get_widget (SwitchboardPlug* base);
static void pc_plug_real_shown (SwitchboardPlug* base);
static void pc_plug_real_hidden (SwitchboardPlug* base);
static void pc_plug_real_search_callback (SwitchboardPlug* base,
                                   const gchar* location);
static void pc_plug_real_search_data_free (gpointer _data);
static void pc_plug_real_search (SwitchboardPlug* base,
                          const gchar* search,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_);
static gboolean pc_plug_real_search_co (PcPlugSearchData* _data_);
static void pc_plug_finalize (GObject * obj);
static GType pc_plug_get_type_once (void);

static inline gpointer
pc_plug_get_instance_private (PCPlug* self)
{
	return G_STRUCT_MEMBER_P (self, PCPlug_private_offset);
}

PCPlug*
pc_plug_construct (GType object_type)
{
	PCPlug * self = NULL;
	GeeTreeMap* settings = NULL;
	GeeTreeMap* _tmp0_;
#line 27 "../src/plug/Plug.vala"
	bindtextdomain (PC_CONSTANTS_GETTEXT_PACKAGE, PC_CONSTANTS_LOCALEDIR);
#line 28 "../src/plug/Plug.vala"
	bind_textdomain_codeset (PC_CONSTANTS_GETTEXT_PACKAGE, "UTF-8");
#line 30 "../src/plug/Plug.vala"
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 30 "../src/plug/Plug.vala"
	settings = _tmp0_;
#line 31 "../src/plug/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "parental-controls", NULL);
#line 33 "../src/plug/Plug.vala"
	self = (PCPlug*) g_object_new (object_type, "category", SWITCHBOARD_PLUG_CATEGORY_SYSTEM, "code-name", "io.elementary.switchboard.parental-controls", "display-name", _ ("Screen Time & Limits"), "description", _ ("Configure time limits and restrict application usage"), "icon", "preferences-system-parental-controls", "supported-settings", settings, NULL);
#line 26 "../src/plug/Plug.vala"
	_g_object_unref0 (settings);
#line 26 "../src/plug/Plug.vala"
	return self;
#line 121 "Plug.c"
}

PCPlug*
pc_plug_new (void)
{
#line 26 "../src/plug/Plug.vala"
	return pc_plug_construct (PC_TYPE_PLUG);
#line 129 "Plug.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 48 "../src/plug/Plug.vala"
	return self ? g_object_ref (self) : NULL;
#line 137 "Plug.c"
}

static GtkWidget*
pc_plug_real_get_widget (SwitchboardPlug* base)
{
	PCPlug * self;
	PCMainBox* _tmp0_;
	PCMainBox* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* result;
#line 43 "../src/plug/Plug.vala"
	self = (PCPlug*) base;
#line 44 "../src/plug/Plug.vala"
	_tmp0_ = self->priv->main_box;
#line 44 "../src/plug/Plug.vala"
	if (_tmp0_ == NULL) {
#line 154 "Plug.c"
		PCMainBox* _tmp1_;
#line 45 "../src/plug/Plug.vala"
		_tmp1_ = pc_main_box_new ();
#line 45 "../src/plug/Plug.vala"
		g_object_ref_sink (_tmp1_);
#line 45 "../src/plug/Plug.vala"
		_g_object_unref0 (self->priv->main_box);
#line 45 "../src/plug/Plug.vala"
		self->priv->main_box = _tmp1_;
#line 164 "Plug.c"
	}
#line 48 "../src/plug/Plug.vala"
	_tmp2_ = self->priv->main_box;
#line 48 "../src/plug/Plug.vala"
	_tmp3_ = _g_object_ref0 ((GtkWidget*) _tmp2_);
#line 48 "../src/plug/Plug.vala"
	result = _tmp3_;
#line 48 "../src/plug/Plug.vala"
	return result;
#line 174 "Plug.c"
}

static void
pc_plug_real_shown (SwitchboardPlug* base)
{
	PCPlug * self;
#line 51 "../src/plug/Plug.vala"
	self = (PCPlug*) base;
#line 183 "Plug.c"
}

static void
pc_plug_real_hidden (SwitchboardPlug* base)
{
	PCPlug * self;
#line 54 "../src/plug/Plug.vala"
	self = (PCPlug*) base;
#line 192 "Plug.c"
}

static void
pc_plug_real_search_callback (SwitchboardPlug* base,
                              const gchar* location)
{
	PCPlug * self;
#line 57 "../src/plug/Plug.vala"
	self = (PCPlug*) base;
#line 57 "../src/plug/Plug.vala"
	g_return_if_fail (location != NULL);
#line 204 "Plug.c"
}

static void
pc_plug_real_search_data_free (gpointer _data)
{
	PcPlugSearchData* _data_;
	_data_ = _data;
#line 23 "../src/plug/Plug.vala"
	_g_free0 (_data_->search);
#line 23 "../src/plug/Plug.vala"
	_g_object_unref0 (_data_->result);
#line 23 "../src/plug/Plug.vala"
	_g_object_unref0 (_data_->self);
#line 23 "../src/plug/Plug.vala"
	g_slice_free (PcPlugSearchData, _data_);
#line 220 "Plug.c"
}

static void
pc_plug_real_search (SwitchboardPlug* base,
                     const gchar* search,
                     GAsyncReadyCallback _callback_,
                     gpointer _user_data_)
{
	PCPlug * self;
	PcPlugSearchData* _data_;
	PCPlug* _tmp0_;
	gchar* _tmp1_;
#line 23 "../src/plug/Plug.vala"
	g_return_if_fail (search != NULL);
#line 23 "../src/plug/Plug.vala"
	self = (PCPlug*) base;
#line 23 "../src/plug/Plug.vala"
	_data_ = g_slice_new0 (PcPlugSearchData);
#line 23 "../src/plug/Plug.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 23 "../src/plug/Plug.vala"
	g_task_set_task_data (_data_->_async_result, _data_, pc_plug_real_search_data_free);
#line 23 "../src/plug/Plug.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 23 "../src/plug/Plug.vala"
	_data_->self = _tmp0_;
#line 23 "../src/plug/Plug.vala"
	_tmp1_ = g_strdup (search);
#line 23 "../src/plug/Plug.vala"
	_g_free0 (_data_->search);
#line 23 "../src/plug/Plug.vala"
	_data_->search = _tmp1_;
#line 23 "../src/plug/Plug.vala"
	pc_plug_real_search_co (_data_);
#line 255 "Plug.c"
}

static GeeTreeMap*
pc_plug_search_finish (SwitchboardPlug* base,
                       GAsyncResult* _res_)
{
	GeeTreeMap* result;
	PcPlugSearchData* _data_;
#line 23 "../src/plug/Plug.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 23 "../src/plug/Plug.vala"
	result = _data_->result;
#line 23 "../src/plug/Plug.vala"
	_data_->result = NULL;
#line 23 "../src/plug/Plug.vala"
	return result;
#line 272 "Plug.c"
}

static gboolean
pc_plug_real_search_co (PcPlugSearchData* _data_)
{
#line 61 "../src/plug/Plug.vala"
	switch (_data_->_state_) {
#line 61 "../src/plug/Plug.vala"
		case 0:
#line 282 "Plug.c"
		goto _state_0;
		default:
#line 61 "../src/plug/Plug.vala"
		g_assert_not_reached ();
#line 287 "Plug.c"
	}
	_state_0:
#line 62 "../src/plug/Plug.vala"
	_data_->_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 62 "../src/plug/Plug.vala"
	_data_->search_results = _data_->_tmp0_;
#line 64 "../src/plug/Plug.vala"
	_data_->_tmp1_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 64 "../src/plug/Plug.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 64 "../src/plug/Plug.vala"
	_data_->_tmp3_ = g_strdup_printf ("%s → %s", _data_->_tmp2_, _ ("Limit computer use"));
#line 64 "../src/plug/Plug.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 64 "../src/plug/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp4_, "");
#line 64 "../src/plug/Plug.vala"
	_g_free0 (_data_->_tmp4_);
#line 65 "../src/plug/Plug.vala"
	_data_->_tmp5_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 65 "../src/plug/Plug.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 65 "../src/plug/Plug.vala"
	_data_->_tmp7_ = g_strdup_printf ("%s → %s", _data_->_tmp6_, _ ("Prevent website access"));
#line 65 "../src/plug/Plug.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 65 "../src/plug/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp8_, "");
#line 65 "../src/plug/Plug.vala"
	_g_free0 (_data_->_tmp8_);
#line 66 "../src/plug/Plug.vala"
	_data_->_tmp9_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 66 "../src/plug/Plug.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 66 "../src/plug/Plug.vala"
	_data_->_tmp11_ = g_strdup_printf ("%s → %s", _data_->_tmp10_, _ ("Prevent application access"));
#line 66 "../src/plug/Plug.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 66 "../src/plug/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp12_, "");
#line 66 "../src/plug/Plug.vala"
	_g_free0 (_data_->_tmp12_);
#line 67 "../src/plug/Plug.vala"
	_data_->result = _data_->search_results;
#line 67 "../src/plug/Plug.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 67 "../src/plug/Plug.vala"
	if (_data_->_state_ != 0) {
#line 67 "../src/plug/Plug.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 67 "../src/plug/Plug.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 340 "Plug.c"
		}
	}
#line 67 "../src/plug/Plug.vala"
	g_object_unref (_data_->_async_result);
#line 67 "../src/plug/Plug.vala"
	return FALSE;
#line 347 "Plug.c"
}

static void
pc_plug_class_init (PCPlugClass * klass,
                    gpointer klass_data)
{
#line 23 "../src/plug/Plug.vala"
	pc_plug_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/plug/Plug.vala"
	g_type_class_adjust_private_offset (klass, &PCPlug_private_offset);
#line 23 "../src/plug/Plug.vala"
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug*)) pc_plug_real_get_widget;
#line 23 "../src/plug/Plug.vala"
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug*)) pc_plug_real_shown;
#line 23 "../src/plug/Plug.vala"
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug*)) pc_plug_real_hidden;
#line 23 "../src/plug/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug*, const gchar*)) pc_plug_real_search_callback;
#line 23 "../src/plug/Plug.vala"
	((SwitchboardPlugClass *) klass)->search = (void (*) (SwitchboardPlug*, const gchar*, GAsyncReadyCallback, gpointer)) pc_plug_real_search;
#line 23 "../src/plug/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_finish = (GeeTreeMap* (*) (SwitchboardPlug*, GAsyncResult*)) pc_plug_search_finish;
#line 23 "../src/plug/Plug.vala"
	G_OBJECT_CLASS (klass)->finalize = pc_plug_finalize;
#line 372 "Plug.c"
}

static void
pc_plug_instance_init (PCPlug * self,
                       gpointer klass)
{
#line 23 "../src/plug/Plug.vala"
	self->priv = pc_plug_get_instance_private (self);
#line 24 "../src/plug/Plug.vala"
	self->priv->main_box = NULL;
#line 383 "Plug.c"
}

static void
pc_plug_finalize (GObject * obj)
{
	PCPlug * self;
#line 23 "../src/plug/Plug.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PC_TYPE_PLUG, PCPlug);
#line 24 "../src/plug/Plug.vala"
	_g_object_unref0 (self->priv->main_box);
#line 23 "../src/plug/Plug.vala"
	G_OBJECT_CLASS (pc_plug_parent_class)->finalize (obj);
#line 396 "Plug.c"
}

static GType
pc_plug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PCPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pc_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PCPlug), 0, (GInstanceInitFunc) pc_plug_instance_init, NULL };
	GType pc_plug_type_id;
	pc_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_PLUG, "PCPlug", &g_define_type_info, 0);
	PCPlug_private_offset = g_type_add_instance_private (pc_plug_type_id, sizeof (PCPlugPrivate));
	return pc_plug_type_id;
}

GType
pc_plug_get_type (void)
{
	static volatile gsize pc_plug_type_id__once = 0;
	if (g_once_init_enter (&pc_plug_type_id__once)) {
		GType pc_plug_type_id;
		pc_plug_type_id = pc_plug_get_type_once ();
		g_once_init_leave (&pc_plug_type_id__once, pc_plug_type_id);
	}
	return pc_plug_type_id__once;
}

SwitchboardPlug*
get_plug (GModule* module)
{
	PCPlug* plug = NULL;
	PCPlug* _tmp0_;
	SwitchboardPlug* result;
#line 71 "../src/plug/Plug.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 72 "../src/plug/Plug.vala"
	g_debug ("Plug.vala:72: Activating Screen Time & Limits plug");
#line 74 "../src/plug/Plug.vala"
	_tmp0_ = pc_plug_new ();
#line 74 "../src/plug/Plug.vala"
	plug = _tmp0_;
#line 75 "../src/plug/Plug.vala"
	result = (SwitchboardPlug*) plug;
#line 75 "../src/plug/Plug.vala"
	return result;
#line 439 "Plug.c"
}

